#define	VGAPAINT_ABOUT_C

#include "about.h"
#include "request.h"
#include "listbox.h"

#define	V_END	-0x8000
#define V_NEXT	0x7FFF

static short logo3d[]={
	-28,-4,-25,+4,-22,-4,V_NEXT,
	-14,-2,-16,-4,-18,-4,-20,-2,-20,+2,-18,+4,-16,+4,-14,+2,-14,+0,-16,+0,V_NEXT,
	-12,+4,-12,-2,-10,-4,- 8,-4,- 6,-2,- 6,+4,V_NEXT,
	-12,+0,- 6,+0,V_NEXT,
	- 4,+4,- 4,-4,+ 0,-4,+ 2,-2,+ 0,+0,- 4,+0,V_NEXT,
	+ 6,-2,+ 8,-2,+10,+0,+10,+4,+ 6,+4,+ 4,+2,+ 6,+0,+10,+0,V_NEXT,
	+12,-2,+12,+4,V_NEXT,
	+12,-4,+12,-4,V_NEXT,
	+14,+4,+14,-2,+18,-2,+20,+0,+20,+4,V_NEXT,
	+24,-4,+24,+2,+26,+4,+28,+4,V_NEXT,
	+22,-2,+28,-2,
	V_END
};

static short letter_V[]={
	-3,-4,0,4,3,-4,V_END
};

static short letter_G[]={
	3,-2,1,-4,-1,-4,-3,-2,-3,2,-1,4,1,4,3,2,3,0,1,0,V_END
};

static short letter_A[]={
	-3,4,-3,-2,-1,-4,1,-4,3,-2,3,4,V_NEXT,-3,0,3,0,V_END
};

static short letter_P[]={
	-3,4,-3,-4,1,-4,3,-2,1,0,-3,0,V_END
};

static short letter_a[]={
	-1,-2,1,-2,3,0,3,4,-1,4,-3,2,-1,0,3,0,V_END
};

static short letter_i[]={
	0,4,0,-2,V_NEXT,0,-4,0,-4,V_END
};

static short letter_n[]={
	-3,4,-3,-2,1,-2,3,0,3,4,V_END
};

static short letter_t[]={
	-1,-4,-1,2,1,4,3,4,V_NEXT,-3,-2,3,-2,V_END
};

static struct Rectangle about_req_negatives[]={
	{   9, 14, 82, 52 },
	{ RECT_END }
};

static struct Listbox about_req_listboxes[]={
	{
		100,15,35*6,22*8,35,22,0,0,-1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,8,NULL
	},
	{ LB_END }
};

static struct Textbox about_textbox;

static struct Requester about_req={
	0,0,320,200,
	REQ_NOSAVEBACK+REQ_NODRAG+REQ_BORDER,
	"About VGAPaint 386",
	7,
	about_req_listboxes,
	NULL,
	NULL,
	NULL,
	NULL,
	about_req_negatives,
	NULL
};

extern char last_build_string[];

	 //345678901234567890123456789012345
static char *about_txt[]={
	(char *)-1,
	"VGAPaint 386 by Avery Lee",
	"",
	&last_build_string[0],
	"",
	"Freeware and open-source forever.",
	"",
	"This is probably the last build of",
	"VP386, ever, unfortunately.  It's",
	"been fun, but I've progressed onto",
	"the, um, *larger* world of Win32",
	"programming and direct color",
	"displays.",
	"",
	"Sincere apologies to Dan Silva and",
	"the rest of the DeluxePaint crew at",
	"Electronic Arts, without which this",
	"program would not exist.",
	NULL
};

void About(void) {
	uchar *offscr=NULL;
	struct BitMap offsbm_struct;
	struct BitMap *offsbm = &offsbm_struct;
	ushort z;
	ushort z2;
	uchar c;
	mouse_coord mx,my,mb;
	double rot=0;

	/* allocate & initialize our off-screen render bitmap */

	if (vidbm.syncrect) {
		offscr=NULL;
		offsbm = &vidbm;
	} else {
		if (!(offscr=(uchar *)malloc(vd->rassize(320,200))))
			goto exit;
		vid_initBitMap(&offsbm_struct,offscr,0,0,320,200,320,vidbm.pal);
	};

	reset_colors();

	vid_loadRGB6(0,stdcol,32);
	for(z=0;z<64;z++) {
		c=256*pow(z/64.0,.5);
		vid_setRGB6(32+z,c,c,c);
	};

	/* zoom each letter on in succession */

	ZoomLetter(offsbm,letter_V);
	ZoomLetter(offsbm,letter_G);
	ZoomLetter(offsbm,letter_A);
	ZoomLetter(offsbm,letter_P);
	ZoomLetter(offsbm,letter_a);
	ZoomLetter(offsbm,letter_i);
	ZoomLetter(offsbm,letter_n);
	ZoomLetter(offsbm,letter_t);

	for(z=96;z>=32;z-=2) {
		vd->set(offsbm,0);
		z2=z*z;
		c=32+(z+z)/3;
		RenderLogo(offsbm,160,100,c,z2);
		VectorRenderList(offsbm,letter_V,160,100,-28,0,c,z2);
		VectorRenderList(offsbm,letter_G,160,100,-20,0,c,z2);
		VectorRenderList(offsbm,letter_A,160,100,-12,0,c,z2);
		VectorRenderList(offsbm,letter_P,160,100,- 4,0,c,z2);
		VectorRenderList(offsbm,letter_a,160,100,  4,0,c,z2);
		VectorRenderList(offsbm,letter_i,160,100, 12,0,c,z2);
		VectorRenderList(offsbm,letter_n,160,100, 20,0,c,z2);
		VectorRenderList(offsbm,letter_t,160,100, 28,0,c,z2);
		WaitVBL();
		mouse_hide();
#if 0
		if (vidbm.syncrect) {
			vidbm.syncx1=vidbm.syncy1=0;
			vidbm.syncx2=319;
			vidbm.syncy2=199;
			vd->refresh();
		} else qmovel((ulong *)0xA0000,(ulong *)offscr,16000);
#else
		if (offsbm != &vidbm)
			vd->bitblt(offsbm,0,0,&vidbm,0,0,offsbm->width,offsbm->height);
#endif
		vd->refresh();
		mouse_show();
	};

//	delay(500);	AVOID DELAY!!!!

	{
		ulong end_tick = read_tick()+30;

		while(read_tick()<end_tick) kbhit();
	}

	/* scale & move the logo to (10,20)-(89,69) */

	for(z=32;z>=16;z-=2) {
//		if (mouse_buttons()) return;
		z2=z-16;
		vd->set(offsbm,0);
		RenderLogo(offsbm,50+(110*z2)/16,40+(60*z2)/16,c,z*z);
		WaitVBL();
		mouse_hide();
#if 0
		if (vidbm.syncrect) {
			vidbm.syncx1=vidbm.syncy1=0;
			vidbm.syncx2=319;
			vidbm.syncy2=199;
			vd->refresh();
		} else qmovel((ulong *)0xA0000,(ulong *)offscr,16000);
#else
		if (offsbm != &vidbm)
			vd->bitblt(offsbm,0,0,&vidbm,0,0,offsbm->width,offsbm->height);
#endif
		vd->refresh();
		mouse_show();
	};

//	mouse_hide();
//	vd->set(&vidbm,ST2);
//	vid_draw3d(&vidbm,0,0,319,10);
//	vd->text6(&vidbm,106,2,"About VGAPaint 386",ST0,ST2);
//	vid_draw3d(&vidbm,0,11,319,199);
//	mouse_show();

	InitTextbox(&about_textbox,&about_req_listboxes[0]);
	about_textbox.table=about_txt;
	TextboxCreate(&about_textbox,TRUE);

	about_req.width = vidbm.width;
	about_req.height = vidbm.height;

	if (!OpenRequester(&about_req,0,0)) goto exit2;

	for(z=0;z<64;z++) {
		c=256*pow(z/64.0,.5);
		vid_setRGB6(32+z,c,c,c);
	};

	for(;;) {
		mouse_read2(&mx,&my,&mb);
		if (mb) break;
		rot+=0.05;
		vd->bar(offsbm,10,15,80,50,0);
		VectorRenderList3D(offsbm,logo3d,50,40,0,0,256,rot);
		WaitVBL();
     		mouse_hide();
#if 0
		if (vidbm.syncrect) {
			vidbm.syncx1=10;
			vidbm.syncy1=15;
			vidbm.syncx2=89;
			vidbm.syncy2=64;
			vd->refresh();
		} else rectcopy((uchar *)(0xA0000+10+15*320),320,(uchar *)(offscr+10+15*320),320,80,50);
#else
		if (offsbm != &vidbm)
			vd->bitblt(offsbm,10,15,&vidbm,10,15,80,50);
		vd->refresh();
#endif
		mouse_show();
	};

	mouse_wait_unkey();

	CloseRequester(&about_req);

exit2:

exit:
	if (offscr) free(offscr);

	restore_screen();
}

static void RenderLogo(BMP dst,coord xb,coord yb,uchar c,ushort z2) {
	VectorRenderList(dst,letter_V,xb,yb,-28,0,c,z2);
	VectorRenderList(dst,letter_G,xb,yb,-20,0,c,z2);
	VectorRenderList(dst,letter_A,xb,yb,-12,0,c,z2);
	VectorRenderList(dst,letter_P,xb,yb,- 4,0,c,z2);
	VectorRenderList(dst,letter_a,xb,yb,  4,0,c,z2);
	VectorRenderList(dst,letter_i,xb,yb, 12,0,c,z2);
	VectorRenderList(dst,letter_n,xb,yb, 20,0,c,z2);
	VectorRenderList(dst,letter_t,xb,yb, 28,0,c,z2);
}

static void ZoomLetter(BMP dst,short *l) {
	ushort z;

	for(z=0;z<96;z+=4) {
		if (mouse_buttons()) return;
		vd->set(dst,0);
		VectorRenderList(dst,l,160,100,0,0,32+(z+z)/3,z*z);
		WaitVBL();
		mouse_hide();
#if 0
		if (vidbm.syncrect) {
			vidbm.syncx1=vidbm.syncy1=0;
			vidbm.syncx2=319;
			vidbm.syncy2=199;
			vd->refresh();
		} else qmovel((ulong *)0xA0000,dst->vm,16000);
#else
		if (dst != &vidbm)
			vd->bitblt(dst,0,0,&vidbm,0,0,dst->width,dst->height);
		vd->refresh();
#endif
		mouse_show();
	};
}

void VectorRenderList(BMP dst,short *vlist,coord xb,coord yb,coord xo,coord yo,color c,ushort zoomfac) {
	short x1,y1,x2,y2;

	for (;;) {
		x1=xb+(((long)(*vlist++ + xo) * zoomfac)>>8);
		if (x1 == V_END) return;
		y1=yb+(((long)(*vlist++ + yo) * zoomfac)>>8);
		x2=xb+(((long)(*vlist++ + xo) * zoomfac)>>8);
		y2=yb+(((long)(*vlist++ + yo) * zoomfac)>>8);
		vd->line(dst,x1,y1,x2,y2,c);
		for(;;) {
			x1=x2;
			y1=y2;
			x2=*vlist++;
			if (x2==V_END) return;
			else if (x2==V_NEXT) break;
			x2=xb+(((long)(x2 + xo) * zoomfac)>>8);
			y2=yb+(((long)(*vlist++ + yo) * zoomfac)>>8);
			vd->line(dst,x1,y1,x2,y2,c);
		};
	};
}

void RotatePoint3D(short *pp,short x,short y,double rotsin,double rotcos) {
	short z;

	*pp++=floor((x*rotcos+128)/256);
	*pp++=(y-(((z=floor(x*rotsin+.5))+4)>>3)+256)>>8;
	*pp++=((z+128)>>8);
};

int VectorRenderList3DCompare(const short *x,const short *y) {
	short k1,k2;

	k1=x[2]+x[6];
	k2=y[2]+y[6];

	return (k1<k2 ? -1 : (k1>k2 ? 1 : 0));
}

void VectorRenderList3D(BMP dst,short *vlist,coord xb,coord yb,coord xo,coord yo,ushort zoomfac,double rot) {
	long x1,y1,x2,y2;
	short buf[512];		/* enough for 64 lines */
	short *lineptr=buf;
	short linecnt=0;
	short maxz,maxz2;
	double rotsin,rotcos;

	rotsin=sin(rot);
	rotcos=cos(rot);

	for (;;) {
		x1=*vlist++;
		if (x1==V_END) break;
		x1=(long)(x1       + xo) * zoomfac;
		y1=(long)(*vlist++ + yo) * zoomfac;
		x2=(long)(*vlist++ + xo) * zoomfac;
		y2=(long)(*vlist++ + yo) * zoomfac;
		for(;;) {
			RotatePoint3D(lineptr,x1,y1,rotsin,rotcos);
			RotatePoint3D(lineptr+4,x2,y2,rotsin,rotcos);
			lineptr+=8;
			linecnt++;
			x1=x2;
			y1=y2;
			x2=*vlist++;
			if (x2==V_END) goto phase2;
			else if (x2==V_NEXT) break;
			x2=(long)(x2       + xo) * zoomfac;
			y2=(long)(*vlist++ + yo) * zoomfac;
		};
	};

	/* okay, lines have been rotated into buffer; now sort them according to depth */

	if (!linecnt) return;

phase2:
	qsort(buf,linecnt,16,(int(*)(const void *,const void *))&VectorRenderList3DCompare);

	/* render them one at a time into the buffer */

	maxz=(56*zoomfac)>>7;
	maxz2=maxz>>1;

	lineptr=buf;
	do {
		vd->line(dst,xb+lineptr[0],yb+lineptr[1],xb+lineptr[4],yb+lineptr[5],

		/* depth ranges from -28 to 28, since x ranges from -28 to 28
		** therefore, we need to scale the range -56 to 56 => 0 to 63.
		*/

			32+((maxz2-(lineptr[2]+lineptr[6]))*64)/maxz

			);
		lineptr+=8;
	} while(--linecnt);
}

