#ifndef VGAPAINT_ANIMIO_H
#define	VGAPAINT_ANIMIO_H

#include <a/types.h>

#ifndef	VGAPAINT_STRUCTS_ONLY
#include "pcx.h"
#endif

#define	VPAH_MAGIC	'NAPV'

struct VPAnimHeader {
	ulong	magic;		// "VPAN"
	ulong	len;		// set to sizeof(struct VPAnimHeader)
	ulong	frames;		// total frames
	ulong	playback_rate;	// playback speed
	ulong	width,height;	// width, height of animation
	ulong	flags;		// nothing for now
	uchar	palette[768];	// palette
	uchar	palbits[32];	// palbits
	ulong	audio_len;	// total audio file length
	ulong	audio_rate;	// audio playback rate
	uchar	audio_channels;	// number of audio channels
};

#define	VPAAH_MAGIC		'DAPV'

struct VPAnimAudioHeader {
	ulong	magic;		// VPAD
	ulong	len;		// set to sizeof(struct VPAnimAudioSegment)+sample_len
	ulong	sequence;	// 0 for the first segment of a sound
	uchar	channel;	// audio channel to play this on
	uchar	pan;		// -127 = full left, 127 = full right
	uchar	volume;		// 0-255
	uchar	pad;
	ulong	sample_len;	// length of sample following this
};

#define	VPFH_MAGIC		'RFPV'
#define	VPFH_COMPMASK		(0x000000FFL)
#define	VPFH_COMP_NONE		(0x00000000L)
#define	VPFH_COMP_BYTERUN	(0x00000001L)
#define	VPFH_COMP_TEMPORAL1	(0x00000002L)
#define	VPFH_COMP_DELTA2HUFFMAN	(0x00000003L)

struct VPFrameHeader {
	ulong	magic;		// "VPFR"
	ulong	len;		// set to sizeof(struct VPFrameHeader)
	ulong	flags;		// flags for this frame
	ulong	framesiz;	// size of the compressed frame data
};

#define	VPPL_MAGIC		'LPPV'

struct VPNewPalette {
	ulong	magic;		// "VPPL"
	ulong	len;
	uchar	palette[768];	// new palette
};

#define	FLC_ID			0xAF12
#define	FLCF_HAS_RING_FRAME	0x0001
#define	FLCF_HEADER_UPDATED	0x0002

struct FLCHeader {
	ulong	total_size;	// 00
	ushort	id;		// 04
	ushort	frame_count;	// 06
	ushort	width;		// 08
	ushort	height;		// 0a
	ushort	bitsperpixel;	// 0c - always 8
	ushort	flags;		// 0e
	ulong	speed;		// 10 - delay in milliseconds
	ushort	_reserved0;	// 14
	ulong	creation_time;	// 16
	ulong	creator;	// 1a
	ulong	modify_time;	// 1e
	ulong	modifier;	// 22
	ushort	x_aspect;	// 26
	ushort	y_aspect;	// 28
	uchar	_reserved1[38];	// 2a
	ulong	offset_first;	// 50
	ulong	offset_second;	// 54
	uchar	_reserved2[40];	// 58
				// 80
};

#define	FLCB_ID		0xF1FA;

struct FLCBlock {
	ulong	size;
	ushort	id;
	ushort	subblocks;
	uchar	_reserved0[8];
};

#define	FLI_COLOR256		4
#define	FLI_SS2			7
#define	FLI_COLOR		11
#define	FLI_LC			12
#define	FLI_BLACK		13
#define	FLI_BRUN		15
#define	FLI_COPY		16
#define	FLI_PSTAMP		18

struct FLCSubBlock {
	ulong	size;
	ushort	type;
};

#ifndef	VGAPAINT_STRUCTS_ONLY
enum PictureIOErrors AnimWriteVP(char *fname,struct Picture *pict,char *audio_fname,boolean use_temporal1,boolean use_delta2);
enum PictureIOErrors AnimReadVP(struct Picture *pict,char *fname,int insert_mode);
enum PictureIOErrors AnimReadPCX(struct Picture *pict,char *fname,int insert_mode);
enum PictureIOErrors AnimWritePCX(struct Picture *pict,char *fname);
enum PictureIOErrors AnimWriteFLC(struct Picture *pict,char *fname);
#endif

#endif
