////////////////////////////////////////////////////
//
// VGAPaint 386 - command.c
//
// Routines for processing commands, particularly from the keyboard and
// from the menus.
//

#include <parm.h>

#define CMD(name) static void name(long arg1,long arg2,long arg3)

//////////////////////////////////////////////////////////////////////
//
////	The following commands have nasty kludges in them that need fixing:
//
//	com_fill_range (locks fillmode at 2)
//
////	The following commands are stubbed:
//
//	com_prefs_scroll_lock
//
//////////////////////////////////////////////////////////////////////

CMD(null) { }
CMD(file_load_autodetect) {
	if (pict_cur->flags & PICT_HASNAME) SetPrevName(pict_cur->name);
	PictureLoad();
}
CMD(file_load_pcx) {
	if (pict_cur->flags & PICT_HASNAME) SetPrevName(pict_cur->name);
	PCXRead(GetFileName("Read PCX file","pcx"),2);
}
CMD(file_load_iff) {
	if (pict_cur->flags & PICT_HASNAME) SetPrevName(pict_cur->name);
	IFFRead(GetFileName("Read IFF file","lbm"));
}
CMD(file_load_pal) {
	if (pict_cur->flags & PICT_HASNAME) SetPrevName(pict_cur->name);
	FileIORespond(PALRead(GetFileName("Load PAL File","pal")));
}
CMD(file_load_bmp) {
	if (pict_cur->flags & PICT_HASNAME) SetPrevName(pict_cur->name);
	FileIORespond(BMPRead(GetFileName("Load BMP File","bmp")));
}
CMD(com_file_save_pcx8) {
	SetPrevName(pict_cur->name);
	FileIORespond(PCXWrite	  (GetFileNameSave("Save PCX-8 File","pcx"),picbm,pict_cur->cur_pal));
}
CMD(com_file_save_pcx4) {
	SetPrevName(pict_cur->name);
	FileIORespond(PCXWrite4   (GetFileNameSave("Save PCX-4 File","pcx"),picbm));
}
CMD(com_file_save_com) {
	SetPrevName(pict_cur->name);
	FileIORespond(PCXCom_Write(GetFileNameSave("Save COM File","com"),picbm));
}
CMD(com_file_save_pak) {
	SetPrevName(pict_cur->name);
	FileIORespond(Pak_Dump	  (GetFileNameSave("Save Raw Data","pak"),picbm));
}
CMD(com_file_save_iff) {
	SetPrevName(pict_cur->name);
	FileIORespond(IFFWrite	  (GetFileNameSave("Save IFF File","lbm"),picbm));
}
CMD(com_file_save_bmp) {
	SetPrevName(pict_cur->name);
	FileIORespond(BMPWrite	  (GetFileNameSave("Save BMP File","bmp"),picbm));
}
CMD(com_file_save_pal) {
	SetPrevName(pict_cur->name);
	FileIORespond(PALWrite	  (GetFileNameSave("Save PAL File","pal"),picbm));
}
CMD(com_file_save_bin) {
	SetPrevName(pict_cur->name);
	FileIORespond(HP48Write3  (GetFileNameSave("Save HP48 File","bin"),picbm));
}
CMD(com_file_save_pcx8sfx) {
	SetPrevName(pict_cur->name);
	FileIORespond(PCXWriteSFX (GetFileNameSave("Save PCX-Sfx File","pcx"),picbm));
}

CMD(com_picture_clear) {
	mouse_hide();
	UndoInvalidate();
	vd->set(winbm,bcolor);
	rectmodified=TRUE;
	rectposx=vposx;
	rectposy=vposy;
	rectx1=winbm->x1;
	recty1=winbm->y1;
	rectx2=winbm->x2-1;
	recty2=winbm->y2-1;
	UndoSave();
	mouse_show();
	vd->refresh();

	PictureMarkDirty(pict_cur);
}
CMD(com_picture_undo) {	Undo(); }
CMD(com_picture_flipx) { pic_flip_x(); }
CMD(com_picture_flipy) { pic_flip_y(); }
CMD(com_picture_rotright) { pic_rotate_right(); }
CMD(com_picture_dither_1x1x1) { Dither8(pict_cur); restore_screen(); }
CMD(com_picture_dither_640x480x16) { Dither16(); }
CMD(com_picture_dither_640x480x2) { Dither2(); }
CMD(com_picture_process_average3) { AverageRGB(FALSE); }
CMD(com_picture_process_average5) { AverageRGB(TRUE); }
CMD(com_picture_process_median3) { MedianRGB(); }
CMD(com_picture_process_invert) { InvertRGB(); }
CMD(com_picture_process_deltahoriz) { DeltaH(); }
CMD(com_picture_process_deltavert) { DeltaV(); }
CMD(com_picture_process_undelhoriz) { UnDeltaH(); }
CMD(com_picture_process_undelvert) { UnDeltaV(); }

CMD(com_picture_color_most2least) { SortPictureColors(TRUE); }
CMD(com_picture_color_least2most) { SortPictureColors(FALSE); }
CMD(com_picture_color_mergesame) { MergeIdenticalColors(NULL); }
CMD(com_picture_color_pcxoptimize) { PCXOptimizeColors(); }

CMD(com_picture_color_brightness) { ToneAdjust(); }
CMD(com_picture_color_balance) { ToneAdjust2(); }
CMD(com_picture_color_control) { ColorControl(); }
CMD(com_picture_color_palette) {
	if (pict_cur->current->frame_pal)
		DoArrange(pict_cur->current->frame_pal->palette,pict_cur->pal_bits,"Frame ");
	else
		DoArrange(pict_cur->palette,pict_cur->pal_bits,"Global ");
}
CMD(com_picture_color_ranges) { DoRange(); }

CMD(com_picture_convert_grey) {
	uchar *c=piccol;
	long x,y;

	for(x=0;x<256;x++) {
		y=(30*c[0]+59*c[1]+11*c[2]+50)/100;
		*c++=*c++=*c++=y;
	};

	repick_colors();
	restore_screen();
}
CMD(com_picture_convert_bw) {
	uchar *c=piccol,y;
	long x;

	for(x=0;x<256;x++) {
		y=(30*c[0]+59*c[1]+11*c[2]+50)>=3175 ? 63 : 0;
		*c++=*c++=*c++=y;
	};

	repick_colors();
	restore_screen();
}
CMD(com_picture_convert_grey256) {
	uchar *c=piccol;
	uchar *p=packmem;
	long x;

	for(x=0;x<256;x++) {
		*p++=(30*c[0]+59*c[1]+11*c[2]+50)/100;
		c+=3;
	};

	vid13_translate(picbm,0,0,picbm->width,picbm->height,packmem);

	c=piccol;
	for(x=0;x<256;x++) { c[0]=c[1]=c[2]=x; c+=3; }

	repick_colors();
	restore_screen();
}
CMD(com_picture_convert_grey64) {
	uchar *c=piccol;
	uchar *p=packmem;
	long x;

	for(x=0;x<256;x++) {
		*p++=(30*c[0]+59*c[1]+11*c[2]+50)/(100*4);
		c+=3;
	};

	vid13_translate(picbm,0,0,picbm->width,picbm->height,packmem);

	c=piccol;
	for(x=0;x<64;x++) { c[0]=c[1]=c[2]=expand6to8(x); c+=3; }

	repick_colors();
	restore_screen();
}
CMD(com_picture_convert_grey16) {
	uchar *c=piccol;
	uchar *p=packmem;
	long x;

	for(x=0;x<256;x++) {
		*p++=(30*c[0]+59*c[1]+11*c[2]+50)/(100*16);
		c+=3;
	};

	vid13_translate(picbm,0,0,picbm->width,picbm->height,packmem);

	c=piccol;
	for(x=0;x<16;x++) { c[0]=c[1]=c[2]=x*17; c+=3; }

	repick_colors();
	restore_screen();
}
CMD(com_picture_convert_grey8) {
	uchar *c=piccol;
	uchar *p=packmem;
	long x,y;

	for(x=0;x<256;x++) {
		*p++=(30*c[0]+59*c[1]+11*c[2]+50)/(100*32);
		c+=3;
	};

	vid13_translate(picbm,0,0,picbm->width,picbm->height,packmem);

	c=piccol;
	for(x=0;x<16;x++) { c[0]=c[1]=c[2]=(x*255L)/7; c+=3; }

	repick_colors();
	restore_screen();
}
CMD(com_picture_overview) { Overview();

CMD(com_picture_scroll) {

CMD(com_file_new) {
CMD(com_file_info) { Info(); }
CMD(com_file_print) { Print(); }
CMD(com_file_about) { About(); }
CMD(com_file_quit) {
	quit=(RequestBoolean("VP386 Warning","Yes",NULL,"No","Quit this great program?")==2);
}

CMD(com_anim_load_van) {
	FileIORespond(AnimReadVP(pict_cur,GetFileName("Load VP386 Anim","van"),FALSE));
	restore_screen();
}
CMD(com_anim_load_multi_pcx) {
	FileIORespond(AnimReadPCX(pict_cur,GetFileName("Load PCX Sequence","pcx"),FALSE));
	restore_screen();
}
CMD(com_anim_load_avi) {
	FileIORespond(AnimReadAVI(pict_cur,GetFileName("Load AVI File","avi"),FALSE));
	restore_screen();
}

CMD(com_anim_save_van) {
	FileIORespond(AnimWriteVP(GetFileNameSave("Save VP386 Anim","van"),pict_cur,NULL,FALSE));
}
CMD(com_anim_save_van_audio) {
	strcpy(packmem,GetFileNameSave("Save VP386 Anim w/Sound","van"));
	FileIORespond(AnimWriteVP(packmem,pict_cur,GetFileName("Audio file","raw"),FALSE));
}
CMD(com_anim_save_multi_pcx) {
	FileIORespond(AnimWritePCX(pict_cur,GetFileNameSave("Save PCX Sequence","pcx")));
}
CMD(com_anim_save_anicur) {
	FileIORespond(AnimWriteANI(pict_cur,GetFileNameSave("Save ANI file","ani")));
}
CMD(com_anim_save_van_t1) {
	FileIORespond(AnimWriteVP(GetFileNameSave("Save VP386 Anim","van"),pict_cur,NULL,TRUE));
}
CMD(com_anim_save_van_t1a) {
	char *s;

	if (s=malloc(768)) {
		strcpy(s,GetFileNameSave("Save VP386 Anim w/Sound","van"));
		FileIORespond(AnimWriteVP(s,pict_cur,GetFileName("Audio file","raw"),TRUE));
		free(s);
	}
}
CMD(com_anim_save_flc) {
	FileIORespond(AnimWriteFLC(pict_cur,GetFileNameSave("Save FLC file","flc")));
}

CMD(com_anim_fpal_attachprev) {
	struct Frame *fr;

	if (pict_cur->total_frames<=1) break;

	fr = pict_cur->current->prev ? pict_cur->current->prev : pict_cur->last;

	if (fr->frame_pal) {
		if (fr->frame_pal != pict_cur->current->frame_pal) {
			DetachFramePalette(pict_cur,pict_cur->current);
			AttachPaletteToFrame(pict_cur,pict_cur->current,fr->frame_pal);
		}
	} else DetachFramePalette(pict_cur,pict_cur->current);
	LoadFramePalette(pict_cur,pict_cur->current);
	SetTitle(NULL);
}
CMD(com_anim_fpal_attachnext) {
	struct Frame *fr;

	if (pict_cur->total_frames<=1) break;

	fr = pict_cur->current->next ? pict_cur->current->next : pict_cur->first;

	if (fr->frame_pal) {
		if (fr->frame_pal != pict_cur->current->frame_pal) {
			DetachFramePalette(pict_cur,pict_cur->current);
			AttachPaletteToFrame(pict_cur,pict_cur->current,fr->frame_pal);
		}
	} else DetachFramePalette(pict_cur,pict_cur->current);
	LoadFramePalette(pict_cur,pict_cur->current);

	SetTitle(NULL);
}
CMD(com_anim_fpal_attachnew) {
	DetachFramePalette(pict_cur,pict_cur->current);
	if (!AttachPaletteToFrame(pict_cur,pict_cur->current,NULL))
		Message("Not enough memory to attach palette");
	LoadFramePalette(pict_cur,pict_cur->current);
	SetTitle(NULL);
}
CMD(com_anim_fpal_detach) {
	DetachFramePalette(pict_cur,pict_cur->current);
	LoadFramePalette(pict_cur,pict_cur->current);
}
CMD(com_anim_fpal_detachall) {
	int i;

	for(i=0;i<pict_cur->total_frames;i++) {
		DetachFramePalette(pict_cur,pict_cur->current);
		PictureNextFrame(pict_cur);
	}
	LoadFramePalette(pict_cur,pict_cur->current);
}
CMD(com_anim_fpal_separate) {
	struct FramePalette *fp = pict_cur->current->frame_pal;

	if (fp) {	// do we even HAVE a frame palette for this frame?
		if (fp->usecount>1) {	// multiplexed palette?
			memcpy(packmem,fp->palette,768);
			DetachFramePalette(pict_cur,pict_cur->current);
			if (!AttachPaletteToFrame(pict_cur,pict_cur->current,NULL))
				Message("Not enough memory to attach palette");
			else {
				memcpy(pict_cur->current->frame_pal->palette,packmem,768);
				SetTitle(NULL);
			}
		}
	}
}
CMD(com_anim_fpal_feather) {
	struct FramePalette *fp = pict_cur->current->frame_pal;
	int i;

	for(i=0;i<pict_cur->total_frames;i++) {
		PictureNextFrame(pict_cur);
		if (fp = pict_cur->current->frame_pal) {	// do we even HAVE a frame palette for this frame?
			if (fp->usecount>1) {	// multiplexed palette?
				memcpy(packmem,fp->palette,768);
				DetachFramePalette(pict_cur,pict_cur->current);
				if (!AttachPaletteToFrame(pict_cur,pict_cur->current,NULL))
					Message("Not enough memory to attach palette");
				else {
					memcpy(pict_cur->current->frame_pal->palette,packmem,768);
					SetTitle(NULL);
				}
			}
		}
	}
}
CMD(com_anim_fpal_align) {
	AnimAlignPalettes(pict_cur);
}

CMD(com_anim_nextframe) {	VP_NextFrame();	}
CMD(com_anim_prevframe) {	VP_PrevFrame();	}
CMD(com_anim_gotoframe) {	VP_GotoFrame();	}
CMD(com_anim_playforward) {	Anim_Playback(pict_cur,NULL);	}
CMD(com_anim_playonce) {	Anim_Playback(pict_cur,ANIM_PLAYBACK_ONCE);	}
CMD(com_anim_pingpong) {	Anim_Playback(pict_cur,ANIM_PLAYBACK_PINGPONG);	}
CMD(com_anim_addframebefore) {	VP_InsertBeforeFrame();
CMD(com_anim_addframeafter) {	VP_InsertAfterFrame();
CMD(com_anim_delframe) {	VP_DeleteCurrentFrame();
CMD(com_anim_setrate) {
CMD(com_anim_editanimpal) {

CMD(com_brush_builtin_dot) {	GetStdBrush(0);	}

CMD(com_brush_prevframe) {	BrushPrevFrame();	}
CMD(com_brush_nextframe) {	BrushNextFrame();	}
CMD(com_brush_addframebefore) {	BrushInsertFrameBefore();	}
CMD(com_brush_addframeafter) {	BrushInsertFrameAfter();	}
CMD(com_brush_delframe) {	BrushDeleteCurrentFrame();	}

CMD(com_brush_color_changetransp) {
CMD(com_brush_color_remap2pal) {

CMD(com_brush_flipx) {		brush_flipx();		}
CMD(com_brush_flipy) {		brush_flipy();		}
CMD(com_brush_rotright) {	brush_rotright();	}
CMD(com_brush_freerot) {
CMD(com_brush_halve) {		brush_halve();		}
CMD(com_brush_double) {		brush_double();		}
CMD(com_brush_doublex) {	brush_doublex();	}
CMD(com_brush_doubley) {	brush_doubley();	}
CMD(com_brush_freescale) {	brush_scale();		}

CMD(com_brush_handle_cycle) {	brush_handle_cycle();	}
CMD(com_brush_handle_center) {
CMD(com_brush_handle_place) {

CMD(com_prepic_colorchart) {
CMD(com_prepic_rgbbars) {
CMD(com_prepic_rainbows) {
CMD(com_prepic_plasma1) {
CMD(com_prepic_gammatest1) {
CMD(com_prepic_gammatest2) {
CMD(com_prepic_maze) {
CMD(com_prepic_stdpal) {

CMD(com_spare_new) {		SpareInit(picbm->width,picbm->height);	}
CMD(com_spare_swap) {		SpareSwap();		}
CMD(com_spare_copy) {		SpareCopy();		}
CMD(com_spare_list) {		SparePictureList();	}
CMD(com_spare_getpal) {		SpareGetPalette();	}
CMD(com_spare_fitpal) {		SpareFitToPalette();	}
CMD(com_spare_merge) {		SpareMerge();		}
CMD(com_spare_delete) {		SpareDelete();		}
CMD(com_spare_underlay) {	SpareUnderlay();	}
CMD(com_spare_overlay) {	SpareOverlay();		}

CMD(com_color_pipette) {
	mouse_setpointer(eyedropper,0,15,col.white,col.black);
	do
		;
	while(!mouse_buttons() && ' '!=kbd_check());

	if (mouse_buttons()) {
		mouse_read_draw(&x,&y,&b,NULL);
		if (vid_fastinside(winbm,x,y))
			((b&1)?&palette_pickColor:&palette_pickHighColor)(vd->point(winbm,x,y));
		mouse_wait_unkey();
	}
	mouse_setpointer(crosshairs,7,7,col.white,col.black);
}
CMD(com_video_mode_req) {	SelectVideoDriver();	}
CMD(com_scroll_speed_req) {
	scroll_speed_req();
	IniAddItem(main_vp386_ini,"Prefs","ScrollSpeed","0x%lx",scroll_speed);
}
CMD(com_reduce_color_cnt_req) {
	reduce_maxcol = RequestSlider("Max Colors To Reduce To",0,256,reduce_maxcol);
}
CMD(com_magnify_cursor) {
	if (zoomstate)
		ZoomOff();
	else
		ZoomOn(vposx+x-winbm->x1,vposy+y-winbm->y1);
}
CMD(com_magnify_ask) {		ZoomHandler();		}

/// all aliases past this point are boolean aliases ///

CMD(com_prefs_repeatdraw) {
	IniAddItem(main_vp386_ini,"Prefs","RepeatDraw","%d",opt.reptdraw = command_boolean_handle(opt.reptdraw,arg1));
}
CMD(com_prefs_coordinates) {
	IniAddItem(main_vp386_ini,"Prefs","Coords","%d",opt.coords = command_boolean_handle(opt.coords,arg1));
	SetTitle(NULL);
}
CMD(com_prefs_aspectratio) {
	IniAddItem(main_vp386_ini,"Prefs","BeSquare","%d",opt.be_square = command_boolean_handle(opt.be_square,arg1));
}
CMD(com_prefs_autotransp) {
	IniAddItem(main_vp386_ini,"Prefs","AutoTransparency","%d",opt.autotransp = command_boolean_handle(opt.autotransp,arg1));
}
CMD(com_prefs_adjbrushpick) {
	IniAddItem(main_vp386_ini,"Prefs","AdjustBrushBounds","%d",opt.adjustBrush = command_boolean_handle(opt.adjustBrush,arg1);
}
CMD(com_prefs_nobrushflicker) {
	IniAddItem(main_vp386_ini,"Prefs","FlickerFreeBrush","%d",opt.brushflickerfree = command_boolean_handle(opt.brushflickerfree,arg1));
}
CMD(com_prefs_usehirestools) {
	IniAddItem(main_vp386_ini,"Prefs","HiresTools","%d",opt.useHiresTools = command_boolean_handle(opt.useHiresTools,arg1));
}
CMD(com_prefs_hogcpu) {
	IniAddItem(main_vp386_ini,"Prefs","ImitateWindows95","%d",opt.CPUhog = command_boolean_handle(opt.CPUhog,arg1));
}
CMD(com_prefs_halfscreen) {

CMD(com_prefs_toolbar_visible) {
	boolean newstate = command_handle_boolean(toolgrid,arg1);

	if (newstate) display_tools(); else erase_tools();
}
CMD(com_prefs_toolbar_bottom) {
	set_tools_mode(toolmode = command_handle_boolean(toolmode,arg1));
}
CMD(com_prefs_toolbar_split) {
	boolean newstate = command_handle_boolean(!!vd->init(VD_GETLINECOMPARE,0,0),arg1);

	if (newstate) {
		if (vd->init(VD_SETLINECOMPARE,vidbm.height-(toolpos.b_height+toolpos.t_height),0)) {
			vd->init(VD_SETSTART,0,toolpos.b_height+toolpos.t_height);
			mouse_set_split(vidbm.height - (toolpos.b_height+toolpos.t_height),toolpos.b_height+toolpos.t_height);
		}
	} else {
		vd->init(VD_SETLINECOMPARE,0,0);
		vd->init(VD_SETSTART,0,0);
		mouse_set_split(0,0);
	}
}

CMD(com_prefs_scroll_lock) { }

/// all aliases past this point are 1-argument aliases ///

CMD(com_paint_mode) {

CMD(com_fill_mode) {
	fillmode = command_handle_numeric(fillmode,0,6,arg1);
	if (fillmode>=2) {	/* spec. fill mode */
		vsd=&vs_drivers[fillmode-2];
		fillmode=2;
	}
}
CMD(com_fill_range) {
	fill_ccrange = command_handle_numeric(fill_ccrange,0,7,arg1);
}

CMD(com_draw_mode) {
CMD(com_draw_range) {

CMD(com_line_mode) {
CMD(com_blit_mode) {

CMD(com_video_density_mode) {

CMD(com_scroll_mode) {
	scroll_mode = command_handle_numeric(scroll_mode,0,1,arg1);
	IniAddItem(main_vp386_ini,"Prefs","ScrollMode","%d",scroll_mode);
}
CMD(com_scroll_speed) {
	scroll_speed = command_handle_numeric(scroll_speed,0,0x7FFFFFFFL,arg1);
	IniAddItem(main_vp386_ini,"Prefs","ScrollSpeed","0x%lx",scroll_speed);
}

CMD(com_reduce_mode) {
	reduce_mode = command_handle_numeric(reduce_mode,0,3,arg1);
	IniAddItem(main_vp386_ini,"Prefs","ReduceMode","%d",reduce_mode);
}
CMD(com_reduce_dither_mode) {
	reducedither_mode = command_handle_numeric(reducedither_mode,0,3,arg1);
}
CMD(com_reduce_place_mode) {
	reduceplace_mode = command_handle_numeric(reduceplace_mode,0,1,arg1);
}
CMD(com_reduce_color_count) {
	reduce_maxcol = command_handle_numeric(reduce_maxcol,1,256,arg1);
}

CMD(com_zoom_size) {
	zoom_x = command_handle_numeric(zoom_x,1,1024,arg1);
	zoom_y = command_handle_numeric(zoom_y,1,1024,arg1);
}
CMD(com_color_fore) {
	palette_pickColor((uchar)command_handle_numeric((long)fcolorpos,0,255,arg1));
}
CMD(com_color_back) {
	palette_pickHighColor((uchar)command_handle_numeric((long)bcolorpos,0,255,arg1));
}

//////////////////////////////////////////////////////////////////////

void (*comvecs[])(long arg1,long arg2,long arg3) {
	com_null,
	com_file_load_autodetect,
	com_file_load_pcx,
	com_file_load_iff,
	com_file_load_pal,
	com_file_load_bmp,
	com_file_save_pcx8,
	com_file_save_pcx4,
	com_file_save_com,
	com_file_save_pak,
	com_file_save_iff,
	com_file_save_bmp,
	com_file_save_pal,
	com_file_save_bin,
	com_file_save_pcx8sfx,
	com_picture_clear,
	com_picture_undo,
	com_picture_flipx,
	com_picture_flipy,
	com_picture_rotright,
	com_picture_dither_1x1x1,
	com_picture_dither_640x480x16,
	com_picture_dither_640x480x2,
	com_picture_process_average3,
	com_picture_process_average5,
	com_picture_process_median3,
	com_picture_process_invert,
	com_picture_process_deltahoriz,
	com_picture_process_deltavert,
	com_picture_process_undelhoriz,
	com_picture_process_undelvert,

	com_picture_color_most2least,
	com_picture_color_least2most,
	com_picture_color_mergesame,
	com_picture_color_pcxoptimize,

	com_picture_color_brightness,
	com_picture_color_balance,
	com_picture_color_control,
	com_picture_color_palette,
	com_picture_color_ranges,

	com_picture_convert_grey,
	com_picture_convert_bw,
	com_picture_convert_grey256,
	com_picture_convert_grey64,
	com_picture_convert_grey16,
	com_picture_convert_grey8,

	com_picture_overview,

	com_picture_scroll,

	com_file_new,
	com_file_info,
	com_file_print,
	com_file_about,
	com_file_quit,

	com_anim_load_van,
	com_anim_load_multi_pcx,
	com_anim_load_avi,

	com_anim_save_van,
	com_anim_save_van_audio,
	com_anim_save_multi_pcx,
	com_anim_save_anicur,
	com_anim_save_van_t1,
	com_anim_save_van_t1a,
	com_anim_save_flc,

	com_anim_fpal_attachprev,
	com_anim_fpal_attachnext,
	com_anim_fpal_attachnew,
	com_anim_fpal_detach,
	com_anim_fpal_detachall,
	com_anim_fpal_separate,
	com_anim_fpal_feather,
	com_anim_fpal_align,

	com_anim_nextframe,
	com_anim_prevframe,
	com_anim_gotoframe,
	com_anim_playforward,
	com_anim_playonce,
	com_anim_pingpong,
	com_anim_addframebefore,
	com_anim_addframeafter,
	com_anim_delframe,
	com_anim_setrate,
	com_anim_editanimpal,

	com_brush_builtin_dot,

	com_brush_prevframe,
	com_brush_nextframe,
	com_brush_addframebefore,
	com_brush_addframeafter,
	com_brush_delframe,

	com_brush_color_changetransp,
	com_brush_color_remap2pal,

	com_brush_flipx,
	com_brush_flipy,
	com_brush_rotright,
	com_brush_freerot,
	com_brush_halve,
	com_brush_double,
	com_brush_doublex,
	com_brush_doubley,
	com_brush_freescale,

	com_brush_handle_cycle,
	com_brush_handle_center,
	com_brush_handle_place,

	com_prepic_colorchart,
	com_prepic_rgbbars,
	com_prepic_rainbows,
	com_prepic_plasma1,
	com_prepic_gammatest1,
	com_prepic_gammatest2,
	com_prepic_maze,
	com_prepic_stdpal,

	com_spare_new,
	com_spare_swap,
	com_spare_copy,
	com_spare_list,
	com_spare_getpal,
	com_spare_fitpal,
	com_spare_merge,
	com_spare_delete,
	com_spare_underlay,
	com_spare_overlay,

	com_color_pipette,

	com_video_mode_req,
	com_scroll_speed_req,
	com_reduce_color_cnt_req,
	com_magnify_cursor,
	com_magnify_ask,

/// all aliases past this point are boolean aliases ///

	com_prefs_repeatdraw,
	com_prefs_coordinates,
	com_prefs_aspectratio,
	com_prefs_autotransp,
	com_prefs_adjbrushpick,
	com_prefs_nobrushflicker,
	com_prefs_usehirestools,
	com_prefs_hogcpu,
	com_prefs_halfscreen,

	com_prefs_toolbar_visible,
	com_prefs_toolbar_bottom,
	com_prefs_toolbar_split,

	com_prefs_scroll_lock,

/// all aliases past this point are 1-argument aliases ///

	com_paint_mode,

	com_fill_mode,
	com_fill_range,

	com_draw_mode,
	com_draw_range,

	com_line_mode,
	com_blit_mode,

	com_video_density_mode,

	com_scroll_mode,
	com_scroll_speed,

	com_reduce_mode,
	com_reduce_dither_mode,
	com_reduce_place_mode,
	com_reduce_color_count,

	com_zoom_size,
	com_color_fore,
	com_color_back,
};
