	.386p
	.model	flat

	extrn	mouse_ptrdispose_ : near

BEGTEXT	segment	para public use32 'CODE'
BEGTEXT	ends

	.data

page_fault_handler_old		df	0
gp_fault_handler_old		df	0
stack_fault_handler_old   	df	0

	.code

	public	InstallExceptionHandlers_

	extrn	_exit_			: near
	extrn	__GETDS			: near

InstallExceptionHandlers_:
	push	ecx

	mov	ax,0202h
	mov	bl,0eh
	int	31h
	mov	dword ptr page_fault_handler_old,edx
	mov	word ptr page_fault_handler_old+4,cx

	mov	ax,0203h
	mov	bl,0eh
	mov	cx,cs
	mov	edx,offset page_fault_handler_
	int	31h

	mov	ax,0202h
	mov	bl,0dh
	int	31h
	mov	dword ptr gp_fault_handler_old,edx
	mov	word ptr gp_fault_handler_old+4,cx

	mov	ax,0203h
	mov	bl,0dh
	mov	cx,cs
	mov	edx,offset gp_fault_handler_
	int	31h

	mov	ax,0202h
	mov	bl,0ch
	int	31h
	mov	dword ptr stack_fault_handler_old,edx
	mov	word ptr stack_fault_handler_old+4,cx

	mov	ax,0203h
	mov	bl,0ch
	mov	cx,cs
	mov	edx,offset stack_fault_handler_
	int	31h

	pop	ecx
	ret

exception_handler_asm_:
	mov	eax,50
	call	_exit_	

SAVEREGS	macro
	push	gs
	push	fs
	push	es
	push	ds
	pushad
	endm

RESTREGS	macro
	popad
	nop		;stupid 386 bug
	pop	ds
	pop	es
	pop	fs
	pop	gs
	endm

restore_all:
	SAVEREGS
	call	__GETDS
	mov	ax,ds
	mov	es,ax
	mov	eax,3
	int	10h
	call	mouse_ptrdispose_
	RESTREGS
	ret

page_fault_handler_:
	call	restore_all
	jmp	cs:fword ptr page_fault_handler_old

gp_fault_handler_:
	call	restore_all
	jmp	cs:fword ptr gp_fault_handler_old

stack_fault_handler_:
	call	restore_all
	jmp	cs:fword ptr stack_fault_handler_old

print_garbage:
	mov	ebp,esp

	call	__GETDS
	push	ds
	pop	es
	cld

;	save message

	push	ecx

;	safe now.  jump to mode 3

	mov	eax,0003h
	int	10h

;	EBP+4C		SS
;	EBP+48		ESP
;	EBP+44		EFlags
;	EBP+40		CS
;	EBP+3C		EIP
;	EBP+2C		GS
;	EBP+28		FS
;	EBP+24		ES
;	EBP+20		DS
;	EBP+1C		EAX
;	EBP+18		ECX
;	EBP+14		EDX
;	EBP+10		EBX
;	EBP+08		EBP
;	EBP+04		ESI
;	EBP+00		EDI

print	macro	addr
	mov	ah,9
	mov	edx,offset addr
	int	21h
	endm

printh8	macro	value
	mov	edi,offset msg0
	mov	eax,value
	call	bintohex8
	print	msg0
	endm

dump8	macro	mem,value
	mov	edi,offset mem
	mov	eax,value
	call	bintohex8
	endm

dump4	macro	mem,value
	mov	edi,offset mem
	mov	ax,value
	call	bintohex4
	endm

;********************************************

	print	msg1
	pop	edx		;restore message
	mov	ah,9
	int	21h

	mov	edi,offset msg2a
	mov	ax,[ebp+40h]
	call	bintohex4
	mov	edi,offset msg2a+5
	mov	eax,[ebp+3ch]
	call	bintohex8
	print	msg2

;***** start dumping registers out

	dump8	msg3a,[ebp+1ch]		;dump EAX
	dump8	msg3b,[ebp+10h]		;dump EBX
	dump8	msg3c,[ebp+18h]		;dump ECX
	dump8	msg3d,[ebp+14h]		;dump EDX
	dump8	msg4a,[ebp+04h]		;dump ESI
	dump8	msg4b,[ebp+00h]		;dump EDI
	dump8	msg4c,[ebp+08h]		;dump EBP
	dump8	msg4d,[ebp+48h]		;dump ESP
	
	print	msg3			;display registers

	mov	cl,"C"			;dump CS
	mov	eax,[ebp+40h]
	call	prdesc

	mov	cl,"S"			;dump SS
	mov	eax,[ebp+4ch]
	call	prdesc

	mov	cl,"D"			;dump DS
	mov	eax,[ebp+20h]
	call	prdesc

	mov	cl,"E"			;dump ES
	mov	eax,[ebp+24h]
	call	prdesc

	mov	cl,"F"			;dump FS
	mov	eax,[ebp+28h]
	call	prdesc

	mov	cl,"G"			;dump GS
	mov	eax,[ebp+2ch]
	call	prdesc

	mov	eax,[ebp+3ch]		;get EIP
	sub	eax,offset BEGTEXT:0	;subtract start of prgm
	mov	edi,offset msg6a
	call	bintohex8
	print	msg6

;****** return to DOS/4GW or PMODE/W

	add	esp,30h

	mov	[esp],offset exception_handler_asm_
	mov	[esp+4],cs
	retf


;*************************************************


hexstr	db	"0123456789ABCDEF"

bintohex4	proc	near
	push	ebx
	push	ecx
	push	edi
	mov	cl,4
	mov	esi,offset hexstr
@1:
	xor	ebx,ebx
	rol	ax,4
	mov	bl,al
	and	bl,0fh
	mov	bl,[esi+ebx]
	mov	[edi],bl
	inc	edi
	dec	cl
	jne	@1
	pop	edi
	pop	ecx
	pop	ebx
	ret
bintohex4	endp

;*************************************************

bintohex8	proc	near
	push	ebx
	push	ecx
	push	edi
	mov	cl,8
	mov	esi,offset hexstr
@1:
	xor	ebx,ebx
	rol	eax,4
	mov	bl,al
	and	bl,0fh
	mov	bl,[esi+ebx]
	mov	[edi],bl
	inc	edi
	dec	cl
	jne	@1
	pop	edi
	pop	ecx
	pop	ebx
	ret
bintohex8	endp

;***************************************************

prdesc	proc	near

	mov	[msg5],cl

	mov	ebx,eax
	push	ebx
	mov	eax,0000000bh
	mov	edi,offset dsc
	int	31h			;get named descriptor

	pop	ebx
	mov	eax,ebx
	mov	edi,offset msg5a	;write descriptor ID
	call	bintohex4

	mov	eax,dword ptr [dsc+4]	;get 2nd descriptor DWORD
	rol	eax,8
	xchg	al,ah
	rol	eax,16
	mov	ax,word ptr [dsc+2]	;we have base in EAX
	mov	edi,offset msg5c
	call	bintohex4

	mov	eax,dword ptr [dsc+4]	;get limit bits 19-16
	mov	ax,word ptr [dsc+0]	;get limit bits 0-15
	and	eax,000fffffh

	mov	ebx,"etyb"		;now write granularity to string
	test	byte ptr [dsc+6],080h	;page granular?
	je	@1
	mov	ebx,"egap"
	shl	eax,12			;<limit>fffh
	add	eax,0fffh
@1:
	mov	dword ptr [msg5e],ebx	;write granularity
	mov	edi,offset msg5b	;write limit
	call	bintohex8

	dump4	msg5d,word ptr [dsc+5]	;write access rights

	mov	ax,"23"
	test	byte ptr [dsc+5],10h	;is it 32 bit?
	jnz	@2
	mov	ax,"61"
@2:
	mov	word ptr [msg5f],ax	;write USExx string

	print	msg5			;write descriptor message out

	ret

prdesc	endp

;***************************************************
;		data definitions
;***************************************************

	.data
dsc	dd	2 dup (?)

; does any of this seem familiar? if not, crash DOS/4GW and look again.

msg0	db	"00000000h",13,10,"$"
msg1	db	"VP386 Exception: ($"
msg2	db	") at "
msg2a	db	"0000:00000000",13,10,"$"
msg3	db	"EAX "
msg3a	db	"00000000h  EBX "
msg3b	db	"00000000h  ECX "
msg3c	db	"00000000h  EDX "
msg3d	db	"00000000h",13,10
msg4	db	"ESI "
msg4a	db	"00000000h  EDI "
msg4b	db	"00000000h  EBP "
msg4c	db	"00000000h  ESP "
msg4d	db	"00000000h",13,10,"$"
msg5	db	"CS= "
msg5a	db	"0000h, USE"
msg5f	db	"32, "
msg5e	db	"page granular, limit "
msg5b	db	"00000000h, base "
msg5c	db	"00000000h, acc "
msg5d	db	"0000h",13,10
	db	"$"
msg6	db	"Crash address (unrelocated): 1:"
msg6a	db	"00000000h",13,10,"$"

_pagefault	db	"page fault$"
_gpfault	db	"GP fault$"
_stackfault	db	"stack fault$"

	end

