#define VGAPAINT_DRAW_C

#include "vgapaint.h"
#include "draw.h"
#include "request.h"
#include "listbox.h"

static struct Zone vpab_zn[]={
	{ 0,0,0,0,ZN_3D+ZN_TEXTRENDER+ZN_SYSTEXT,NULL,"Ok" },
	{ -1,-1,-1,-1 },
	{ 0,0,0,0,ZN_3D			},	// square
	{ 0,0,0,0,ZN_3D+ZN_FITRIGHT	},	// circle
	{ 0,0,0,0,ZN_3D+ZN_FITRIGHT	},	// diamond
	{ 0,0,0,0,ZN_3D+ZN_FITRIGHT	},	// right slash
	{ 0,0,0,0,ZN_3D+ZN_FITRIGHT	},	// left slash
	{ -1,-1,-1,-1 }
};

static struct ZoneRange vpab_zr[]={
	{ &vpab_zr[1],&vpab_zn[0],NULL,-1,ZR_TAP },
	{ NULL,&vpab_zn[2],NULL,-1,ZR_CHOICE },
};

static struct Requester vpab_req={
	0,0,0,0,REQ_BORDER+REQ_POPCEN+REQ_FORCECOL+REQ_COORDBIAS+REQ_SLDREPHIT+REQ_SYSTITLE,
	"Airbrush",
	St2,
	NULL,		//listboxes
	NULL,		//fields
	vpab_zr,	//zoneranges
	NULL,		//sliders
	NULL,NULL,	//positives,negatives
	NULL,		//texts
};

void	VPRequestAirbrushOpts(void) {
	boolean		quit = FALSE;
	ulong		msg;
	int		i;
	mouse_coord	mx,my,mb;

	vpab_zr[1].highindex = vpopts.airbrush.shape;
	vpab_zr[1].highlighted = &vpab_zn[2+vpopts.airbrush.shape];

	for(i=2;i<=6;i++) {
		vpab_zn[i].x = XPOINT*2;
		vpab_zn[i].y = YPOINT*2;
		vpab_zn[i].xs= XPOINT*15;
		vpab_zn[i].ys= YPOINT*15;
	}

	vpab_req.width = XPOINT*(15*5+4);
	vpab_req.height = YPOINT*19 + sysfontheight+4*YPOINT-1;

	vpab_zn[0].x = XPOINT*2;
	vpab_zn[0].y = YPOINT*17;
	vpab_zn[0].xs= vpab_req.width-XPOINT*4;
	vpab_zn[0].ys= sysfontheight+4*YPOINT-1;

	if (!OpenRequester(&vpab_req,0,0)) return;

	// coordinates have been assigned to the icons, so render them!

	mouse_hide();
	for(i=2;i<=6;i++) {
		coord	x,y,xs,ys;

		x = vpab_zn[i].x+XPOINT*2;
		y = vpab_zn[i].y+YPOINT*2;
		xs = XPOINT*11;
		ys = YPOINT*11;

		switch(i) {
		case 2:	vid_circle(&vpab_req.reqbm,x+(xs>>1),y+(xs>>1),(ys>>1),St0); break;
		case 3: vid_box(&vpab_req.reqbm,x,y,x+xs-1,y+ys-1,St0); break;
		case 4: vid_polyline(&vpab_req.reqbm,St0,0x80000003,
				x,y+(ys>>1),
				x+(xs>>1),y,
				x+xs-1,y+(ys>>1),
				x+(xs>>1),y+ys-1); break;
		case 5: vd->line(&vpab_req.reqbm,x+xs-1,y,x,y+ys-1,St0); break;
		case 6: vd->line(&vpab_req.reqbm,x,y,x+ys-1,y+ys-1,St0); break;
		}
	}
	mouse_show();

	vd->refresh();

	while(!quit) {
		mouse_read2(&mx,&my,&mb);

		switch(msg = CheckRequester(&vpab_req,mx,my,mb)) {
		case RZoneMsg(0,0):
			quit=TRUE;
			break;
		}
	}

	CloseRequester(&vpab_req);

	vpopts.airbrush.shape = vpab_zr[1].highindex;
}

