#ifndef	INIFILE_H
#define	INIFILE_H

#include <stdio.h>

#include <a/types.h>

#define	INI_ITEM_NAME_MAX	40
#define	INI_GROUP_NAME_MAX	40
#define	INI_MAX_STRING		256

#define	INI_SLONG	(0)
#define	INI_ULONG	(1)
#define	INI_STRING	(2)
#define	INI_DSTRING	(3)
#define	INI_DSTRLIT	(4)
#define	INI_DSTRLST	(5)
#define	INI_FLOAT	(6)
#define	INI_BOOL	(7)
#define	INI_FUNCTION	(8)

#define	INI_TYPEMASK	(0x7fff)
#define	INI_FOUND	(0x8000)

struct IniItem {
	char *	name;
	union {
		long	ivalue;
		float	fvalue;
	};
	long	low;
	long	high;
	ushort	type;
	ushort	pad;
	long	deflt;
};

struct IniGroup {
	char *name;
	struct IniItem *items;
};

struct	IniFileLine {
	struct IniFileLine *next,*prev;
	char line[1];
};

struct	IniFile {
	struct IniFileLine *first;
};

char *		strcprocess(char *dest,const char *src);
ulong		IniProcessFile(FILE *f,struct IniGroup *iglist);
ulong		IniProcessFileMem(struct IniFile *inif,struct IniGroup *iglist);
struct IniFile *IniCreateFile(void);
struct IniFile *IniReadFile(FILE *f);
boolean		IniWriteFile(FILE *f,struct IniFile *inif);
void		IniClearItemFoundFlags(struct IniItem *ii);
boolean		IniAddItem(struct IniFile *inif,char *groupname,char *itemname,char *format, ...);

#endif

	
