#define	VGAPAINT_PALETTE_C

#include <math.h>

#include <a/bits.h>

#include "palette.h"
#include "vgapaint.h"
#include "list.h"

#include "palpoint.c"

extern uchar palette_knob[];
extern struct Sprite p_knob_sprite;
extern uchar palette_brightknob[];
extern struct Sprite p_bknob_sprite;
extern uchar palette_transcurs[];
extern struct Sprite p_trans_sprite;
extern struct Rectangle palette_rects[];
extern ushort packed_uparrow[],packed_downarrow[];

uchar ColorVal(short i) {
	while(i>=360) i-=360;
	if	(i<=60)	return (uchar)255;
	else if	(i<120) return (uchar)(((120-i)<<8)/60);
	else if (i<240) return (uchar)0;
	else if (i<300)	return (uchar)(((i-240)<<8)/60);
	else		return (uchar)255;
}

uchar ColorVal2(double i) {
	return ColorVal3(rad_to_deg(i));
}

uchar ColorVal3(double i) {
	i=fmod(i,360);
	if	(i<=60.0) return (uchar)255;
	else if	(i<120.0) return (uchar)(((120.0-i)*256)/60);
	else if (i<240.0) return (uchar)0;
	else if (i<300.0) return (uchar)(((i-240.0)*256)/60);
	else		  return (uchar)255;
}

void DoPalette(void) {
	int i,red,grn,blu;
	int tx,ty,Tx,Ty;
	int kbd;
	mouse_coord x,y,b;
	uchar *cpal = packmem;

	cpage=0;
	bright=127;
	hue=0.0;
	huered=huegrn=hueblu=255;

	vid_loadRGB6(0,stdcol,16);

	for (i=0;i<45;i++) {
		red=(int)ColorVal(i*8);
		grn=(int)ColorVal(i*8+120);
		blu=(int)ColorVal(i*8+240);

		*cpal++ = red;
		*cpal++ = grn;
		*cpal++ = blu;

		*cpal++ = (255+red*3)>>2;
		*cpal++ = (255+grn*3)>>2;
		*cpal++ = (255+blu*3)>>2;

		*cpal++ = (255+red  )>>1;
		*cpal++ = (255+grn  )>>1;
		*cpal++ = (255+blu  )>>1;

		*cpal++ = (767+red  )>>2;
		*cpal++ = (767+grn  )>>2;
		*cpal++ = (767+blu  )>>2;
	};

	vid_loadRGB6(76,packmem,180);

	mouse_hide();
	vd->set(&vidbm,0);

	{
//		long radx=dcos(-4)*65536L,rady=dsin(-4)*65536L;
//		long radx2,rady2;
//		long ix=dcos(360.0/540.0)*65536L,iy=dsin(360.0/540.0)*65536L;
//		coord rx,ry;
//
//		for (i=0;i<540;i++) {
//			getch();
//			rx=(3*80*radx+32768)>>16; ry=(3*72*rady+32768)>>16;
//			tx=80+rx/3; ty=100-ry/3;
//			vd->line(&vidbm,Tx=80+rx/ 4,Ty=100-ry/ 4,tx,ty,76+((i/3)&~3));
//			vd->line(&vidbm,tx=80+rx/ 6,ty=100-ry/ 6,Tx,Ty,77+((i/3)&~3));
//			vd->line(&vidbm,Tx=80+rx/12,Ty=100-ry/12,tx,ty,78+((i/3)&~3));
//			vd->line(&vidbm,   80      ,   100      ,Tx,Ty,79+((i/3)&~3));
//			radx2=fixed_mul32(radx,ix)-fixed_mul32(rady,iy);
//			rady2=fixed_mul32(rady,ix)+fixed_mul32(radx,iy);
//			radx=radx2;
//			rady=rady2;
//		};

		uchar *pm=(char *)palptdata;
		short x=sizeof palptdata/5;
		color c;
		coord rx,ry;

		do {
			rx=*(short *)pm;	pm+=2;
			ry=*(short *)pm;	pm+=2;
			c=*pm++;
			tx=80+rx/3; ty=100-ry/3;
			vd->line(&vidbm,Tx=80+rx/ 4,Ty=100-ry/ 4,tx,ty,76+c);
			vd->line(&vidbm,tx=80+rx/ 6,ty=100-ry/ 6,Tx,Ty,77+c);
			vd->line(&vidbm,Tx=80+rx/12,Ty=100-ry/12,tx,ty,78+c);
			vd->line(&vidbm,   80      ,   100      ,Tx,Ty,79+c);
		} while(--x);
	}

	vd->quickfill(&vidbm,0,28,160,144);

	vd->bar(&vidbm,240,2,20,20,75);
	vd->box(&vidbm,238,0,261,23,7);

	for (i=0;i<8;i++) {
		vd->bar(&vidbm,i*16+190,118,16,20,16+i);
		vd->bar(&vidbm,i*16+190,138,16,20,24+i);
		vd->bar(&vidbm,i*16+190,158,16,20,32+i);
		vd->bar(&vidbm,i*16+190,178,16,20,40+i);
	};

	select_page(0);

	vd->box(&vidbm,188,116,319,199,7);
	vd->box(&vidbm,14,0,145,11,7);

	for (i=48;i<64;i++)
		vd->bar(&vidbm,(i<<3)-368,2,8,8,i);

	sprite_init(&p_knob_sprite,p_knob_sprite.imgbm.vm,p_knob_sprite.savebm.vm,&vidbm,p_knob_sprite.width);
	sprite_init(&p_bknob_sprite,p_bknob_sprite.imgbm.vm,p_bknob_sprite.savebm.vm,&vidbm,p_bknob_sprite.width);
	sprite_quikmove(&p_knob_sprite,78,98);
	sprite_quikmove(&p_bknob_sprite,140,10);

	for (i=0;i<114;i+=18) {
		vd->bltpattern(&vidbm,packed_uparrow  ,191+i, 30,9,5,7,0);
		vd->bltpattern(&vidbm,packed_downarrow,191+i, 48,9,5,7,0);
		vd->bar(&vidbm,186+i,36,19,11,7);
		vd->box(&vidbm,186+i,28,204+i,54,15);
		if (i==36) i+=6;
	};

	vd->text6(&vidbm,193,56,"R  G  B   H  S  V",7,0);

	refresh_color(TRUE);

	mouse_show();
	vd->refresh();

	x=y=-1;

	do {
		do {
			mouse_read2(&x,&y,&b);
		} while(!b && (kbd=kbd_check())==-1);
		if (b) {
			if (sprite_pointcoll(&p_knob_sprite,x,y)) {
				move_cwheel_knob(x,y);
			} else if (sprite_pointcoll(&p_bknob_sprite,x,y)) {
				move_bright_knob(x,y);
			} else switch(rectSearch(palette_rects,x,y)) {
				case 0: dragColor(curred,curgrn,curblu);
					break;
				case 1: x=3*(cpage+((x-190)>>4)+(((y-118)/20)<<3));
					dragColor(piccol[x],piccol[x+1],piccol[x+2]);
					break;
				case 2: dragRGB(&palette_rects[2],&curred,1,256,TRUE);
					break;
				case 3: dragRGB(&palette_rects[3],&curgrn,1,256,TRUE);
					break;
				case 4: dragRGB(&palette_rects[4],&curblu,1,256,TRUE);
					break;
				case 5: dragHue(&palette_rects[5],1.0);
					break;
				case 6: dragRGB(&palette_rects[6],&sat,1,256,FALSE);
					break;
				case 7: dragRGB(&palette_rects[7],&bright,1,128,FALSE);
					break;
				case 8: dragRGB(&palette_rects[8],&curred,-1,256,TRUE);
					break;
				case 9: dragRGB(&palette_rects[9],&curgrn,-1,256,TRUE);
					break;
				case 10: dragRGB(&palette_rects[10],&curblu,-1,256,TRUE);
					break;
				case 11: dragHue(&palette_rects[11],-1.0);
					break;
				case 12: dragRGB(&palette_rects[12],&sat,-1,256,FALSE);
					break;
				case 13: dragRGB(&palette_rects[13],&bright,-1,128,FALSE);
					break;
				};
		};
		if (kbd!=-1) switch(kbd) {
			case 0x148: select_page(cpage-8); break;
			case 0x150: select_page(cpage+8); break;
			};
	} while(kbd!=' ' && kbd!=0x1b);

	mouse_hide();
	repick_colors();
	restore_screen();
	mouse_show();
//	vid_loadRGB6(0,piccol,256);
}

void move_cwheel_knob(coord x,coord y) {
	coord ox,oy,b,offx,offy,x2,y2;
	double dist,dist2;

	offx=(ox=x)-p_knob_sprite.x;
	offy=(oy=y)-p_knob_sprite.y;
	do {
		do {
			mouse_read2(&x,&y,&b);
		} while(ox==x && oy==y && b);
		ox=x; oy=y;
		x-=offx;
		y-=offy;
		hue=rect_to_polar(x2=(x-78),y2=(((y-98)*10)/9));
		dist=sqrt((long)x2*x2+(long)y2*y2);
		dist2=min(dist/80.0,1.0);
		sat=255.9999999999999*dist2;
		huered=ColorVal2(hue);
		huegrn=ColorVal2(hue+M_PI*2.0/3.0);
		hueblu=ColorVal2(hue+M_PI*4.0/3.0);
		refresh_color(TRUE);
		mouse_hide();
		if (dist<=80)
			sprite_quikmove(&p_knob_sprite,x,y);
		else
			sprite_quikmove(&p_knob_sprite,78+80*cos(hue),98-72*sin(hue));
		vd->refresh();
		mouse_show();
	} while(b);
}

double rect_to_polar(coord x,coord y) {
	boolean flip=FALSE;
	double ang,quadrant;

	if (!x && !y) return 0;

	if (x<0) {
		x=-x;
		quadrant=M_PI/2;
		flip=TRUE;
	} else quadrant=0;
	if (y>0) {
		quadrant=M_PI*1.5-quadrant;
		flip=!flip;
	} else y=-y;

	if (x>y) ang=atan((double)y/x);
	else     ang=(M_PI/2-atan((double)x/y));
	if (flip) ang=M_PI/2-ang;
	return ((double)quadrant)+ang;
}

void select_page(short page) {
	short i;

	if (page<0) cpage=0;
	else if (page>224) cpage=224;
	else cpage=page & 248;

	vid_loadRGB6(16,piccol+3*cpage,32);

	mouse_hide();
	for (i=0;i<4;i++)
		vid_printf6(&vidbm,168,124+20*i,7,0,"%3d",cpage+(i<<3));
	vd->refresh();
	mouse_show();
}

void refresh_color(boolean chgflag) {
	int i;
	uchar red,grn,blu;
	long ired,igrn,iblu;
	uchar *cpal = packmem;

	ired=(long)huered*(long)sat+255L*(255-sat);
	igrn=(long)huegrn*(long)sat+255L*(255-sat);
	iblu=(long)hueblu*(long)sat+255L*(255-sat);
	for (i=0;i<16;i++) {
		*cpal++ = (i*ired)/3825;
		*cpal++ = (i*igrn)/3825;
		*cpal++ = (i*iblu)/3825;
	};
	vid_loadRGB6(48,packmem,16);
	red=(((long)huered*(long)sat+255L*(255-sat))*bright)/32385;
	grn=(((long)huegrn*(long)sat+255L*(255-sat))*bright)/32385;
	blu=(((long)hueblu*(long)sat+255L*(255-sat))*bright)/32385;
	if (chgflag) {
		curred=red;
		curgrn=grn;
		curblu=blu;
	};
	vid_setRGB6(75,red,grn,blu);
	vid_printf6(&vidbm,247,38,0,7,"%3.0f",rad_to_deg(hue));
	vid_printf6(&vidbm,265,38,0,7,"%3d",sat);
	vid_printf6(&vidbm,283,38,0,7,"%3d",bright);
	vid_printf6(&vidbm,187,38,0,7,"%3d",curred);
	vid_printf6(&vidbm,205,38,0,7,"%3d",curgrn);
	vid_printf6(&vidbm,223,38,0,7,"%3d",curblu);
	vd->refresh();
}

void move_bright_knob(coord x,coord y) {
	coord ox,oy,b,offx,offy;

	offx=(ox=x)-p_bknob_sprite.x;
	offy=(oy=y)-p_bknob_sprite.y;
	do {
		do {
			mouse_read2(&x,&y,&b);
		} while(ox==x && oy==y && b);
		ox=x; oy=y;
		x-=offx;
		y-=offy;
		mouse_hide();
		if (x<13) {
			sprite_quikmove(&p_bknob_sprite,13,10);
			bright=0;
		} else if (x>=141) {
			sprite_quikmove(&p_bknob_sprite,140,10);
			bright=127;
		} else {
			sprite_quikmove(&p_bknob_sprite,x,10);
			bright=x-13;
		};
		vd->refresh();
		mouse_show();
		refresh_color(TRUE);
	} while(b);
}

void dragColor(uchar red,uchar grn,uchar blu) {
	coord ox=-1;
	coord oy=-1;
	coord x,y,b;
	boolean mode;

	vid_setRGB6(74,red,grn,blu);
	sprite_init(&p_trans_sprite,p_trans_sprite.imgbm.vm,p_trans_sprite.savebm.vm,&vidbm,p_trans_sprite.width);

	mouse_read2(&x,&y,&b);

	mouse_hide();

	if (b & 2) {
		sprite_quikmove(&p_trans_sprite,250,12);
		vd->refresh();
		do {
			mouse_read2(&x,&y,&b);
		} while(b);
		mode=FALSE;
	} else {
		do {
			do {
				mouse_read2(&x,&y,&b);
			} while(ox==x && oy==y && b);
			ox=x; oy=y;
			sprite_quikmove(&p_trans_sprite,x,y);
			vd->refresh();
		} while(b);
		mode=TRUE;
	};

	sprite_erase(&p_trans_sprite);
	vd->refresh();

	mouse_show();

	if (mode) b=rectSearch(palette_rects,x,y);

	switch(b) {
	case 0:	RGBtoHSV(red,grn,blu);
		break;
	case 1:	x=3*(cpage+(b=((x-190)>>4)+(((y-118)/20)<<3)));
		vid_setRGB6(16+(b & 31),piccol[x]=red,piccol[x+1]=grn,piccol[x+2]=blu);
		break;
	};
}

/*  90: red
**  30: yellow
** 330: green
** 270: cyan
** 210: blue
** 150: magenta
**
**  90- 30: red1,grn+,blu0
**  30-330: red-,grn1,blu0
** 330-270: red0,grn1,blu+
** 270-210: red0,grn-,blu1
** 210-150: red+,grn0,blu1
** 150- 90: red1,grn0,blu-
*/

void RGBtoHSV2(uchar red,uchar grn,uchar blu) {
	uchar norm;
	uchar low,high;

	curred=red; curgrn=grn; curblu=blu;

/* step 1: determine top lumination. */

	if (red>grn)	if (red>blu)	bright=(high=red)>>1;
			else		bright=(high=blu)>>1;
	else		if (grn>blu)	bright=(high=grn)>>1;
			else		bright=(high=blu)>>1;

/* step 2: normalize RGB so that we have a zero and a 255. */

	low=min(min(red,grn),blu);
	red-=low;
	grn-=low;
	blu-=low;
	norm=high-low;

	if (norm) {
		huered=(255L*red)/norm;
		huegrn=(255L*grn)/norm;
		hueblu=(255L*blu)/norm;
	} else {
		huered=huegrn=hueblu=255;
	};

/* step 3: convert normalized RGB into a hue. */

	if (huered==255)
		if (!hueblu)	hue=deg_to_rad(360.0-(huegrn*60.0)/256.0);
		else		hue=deg_to_rad(      (hueblu*60.0)/256.0);
	else if (huegrn==255)
		if (!huered)	hue=deg_to_rad(240.0-(hueblu*60.0)/256.0);
		else		hue=deg_to_rad(240.0+(huered*60.0)/256.0);
	else	if (!huegrn)	hue=deg_to_rad(120.0-(huered*60.0)/256.0);
		else		hue=deg_to_rad(120.0+(huegrn*60.0)/256.0);

	if (hue >= 2*M_PI) hue-=2*M_PI;
	if (hue == -0.0) hue=0;	/* 387/487 peculiarity */

	sat=(!high)?255:(255*(high-low))/high;
}

void RGBtoHSV(uchar red,uchar grn,uchar blu) {
	RGBtoHSV2(red,grn,blu);
	mouse_hide();
	sprite_quikmove(&p_knob_sprite,78+80*((sat*cos(hue))/255),98-72*((sat*sin(hue))/255));
	sprite_quikmove(&p_bknob_sprite,13+bright,10);
	refresh_color(FALSE);
	mouse_show();
}

void dragRGB(struct Rectangle *gadget,uchar *colvar,coord dir,coord limit,boolean flag) {
	mouse_coord x,y,b;
	short t=12;
	short dir2=dir;
	short tval;
	long tick,ntick;
	rectInvert(gadget);
	tick=read_tick()-12;
	do {
		if ((ntick=read_tick())-tick>=t) {
			tick=ntick;
			t-=3;
			if (t<1) t=1,dir2+=dir;
			if (dir2<-8) dir2=-8; else if (dir2>8) dir2=8;
			tval=(short)(*colvar)+dir2;
			if (tval<0) tval=0; else if (tval>=limit) tval=limit-1;
			*colvar=(uchar)tval;
			mouse_hide();
			if (flag)
				RGBtoHSV(curred,curgrn,curblu);
			else {
				sprite_quikmove(&p_knob_sprite,78+80*((sat*cos(hue))/255),98-72*((sat*sin(hue))/255));
				sprite_quikmove(&p_bknob_sprite,13+bright,10);
				refresh_color(TRUE);
			};
			mouse_show();
		};
		mouse_read2(&x,&y,&b);
	} while(b);
	rectInvert(gadget);
}

void dragHue(struct Rectangle *gadget,double dir) {
	mouse_coord x,y,b;
	short t=12;
	double dir2;
	long tick,ntick;

	dir2=dir=deg_to_rad(dir/2.0);

	rectInvert(gadget);
	tick=read_tick()-12;
	do {
		if ((ntick=read_tick())-tick>=t) {
			tick=ntick;
			t-=3;
			if (t<1) t=1,dir2+=(dir<0)? -deg_to_rad(.1) : deg_to_rad(.1);
			if (dir2<deg_to_rad(-8.0)) dir2=deg_to_rad(-8.0); else if (dir2>deg_to_rad(8.0)) dir2=deg_to_rad(8.0);
			hue+=dir2;
			if (hue<0.0) hue=hue+2*M_PI; else if (hue>=2*M_PI) hue-=2*M_PI;
			if (hue==-0.0) hue=0.0;
			mouse_hide();
			sprite_quikmove(&p_knob_sprite,78+80*((sat*cos(hue))/255),98-72*((sat*sin(hue))/255));
			huered=ColorVal2(hue);
			huegrn=ColorVal2(hue+M_PI*2.0/3.0);
			hueblu=ColorVal2(hue+M_PI*4.0/3.0);
			refresh_color(TRUE);
			mouse_show();
		};
		mouse_read2(&x,&y,&b);
	} while(b);
	rectInvert(gadget);
}
