#define	VGAPAINT_TONE_C

#include <a/bits.h>

#include "tone.h"
#include "tools.h"
#include "listbox.h"
#include "request.h"
#include "menu.h"

#include <math.h>

static void Try_Colors(uchar bright,uchar contrast,uchar igamma);
static void Try_Colors2(uchar igammar,uchar igammag,uchar igammab);
static void ToneAdjustMain(void (*TCF)(uchar,uchar,uchar),ushort Icons[3][8]);
static void MonitorGammaTry(uchar,uchar,uchar);
static void MonitorGammaSet2(double gammar,double gammag,double gammab);

ushort ToneIcon[6][8]={
	{ 0x1000,0x5A00,0x2400,0x4300,0xC200,0x2400,0x5A00,0x0800 },
	{ 0x3C00,0x4E00,0x8F00,0x8F00,0x8F00,0x8F00,0x4E00,0x3C00 },
	{ 0x0100,0x0100,0x0100,0x0300,0x0300,0x0700,0x1F00,0xFF00 },
	{ 0xFC00,0xC600,0xC300,0xC300,0xFE00,0xC600,0xC300,0xC300 },
	{ 0x3C00,0x6600,0xC300,0xC000,0xCF00,0xC300,0x6600,0x3C00 },
	{ 0xFE00,0xC300,0xC300,0xFE00,0xC300,0xC300,0xC300,0xFE00 }
};
  	
static uchar ToneKnobOriginal[]={
	3,3,3,3,3,3,3,1,
	3,2,2,2,2,2,2,0,
	3,2,2,2,2,2,2,0,
	3,2,2,2,2,2,2,0,
	3,2,2,2,2,2,2,0,
	1,0,0,0,0,0,0,0,
},ToneKnobImage[sizeof ToneKnobOriginal],
  ToneKnobSave[3][sizeof ToneKnobOriginal];

static struct Sprite ToneKnob[3];
static ushort *backpal;

#define	XSIZE	(32)
#define	YSIZE	(80)
#define	XOFF	(288)
#define	YOFF	(120)
#define	XSPR	(XOFF+4)
#define	YSPR	(YOFF+2)

static struct StdColor RGBset={
	0,21,42,63,63,255
};

/* widen: widen 8 bits to 16 */

void ToneAdjust(void) {
	ToneAdjustMain(&Try_Colors,ToneIcon);
}

void ToneAdjust2(void) {
	ToneAdjustMain(&Try_Colors2,&ToneIcon[3]);
}

void ToneAdjustMain(void (*TCF)(uchar,uchar,uchar),ushort Icon[3][8]) {
	mouse_coord x,y,b;
	int z;

	if (!(backpal=(ushort *)malloc(sizeof(ushort[768])))) return;

	/* copy colors into our 'wide' byte array */

	{
		uchar *c=piccol;
		ushort *w=backpal;
		for(z=768;z;z--) *w++=expand8to16L(*c++);
	}

	sprite_3dtranslate(ToneKnobImage,ToneKnobOriginal,sizeof ToneKnobOriginal);

	for(x=0;x<3;x++) {
		ToneKnob[x].width	=8;
		ToneKnob[x].height	=6;
		ToneKnob[x].flags	=SPR_MATTE;
		ToneKnob[x].trans_colr	=STT;
		sprite_init(&ToneKnob[x],ToneKnobImage,ToneKnobSave[x],&vidbm,ToneKnob[x].width);
	};

	mouse_hide();
	vd->bar(&vidbm,XOFF,YOFF,XSIZE,YSIZE,ST2);
	vid_draw3d(&vidbm,XOFF,YOFF,XOFF+XSIZE-1,YOFF+YSIZE-1);

	for(y=0;y<32;y++) {
		for(x=0;x<8;x++) {
			vd->bar(&vidbm,XOFF+XSIZE-24+x*3,YOFF-120+y*3,3,3,(y<<3)+x);
		};
	};

	vd->hline(&vidbm,XSPR-3,XSPR+6+20,YSPR+31,ST1);
	vd->hline(&vidbm,XSPR-3,XSPR+6+20,YSPR+38,ST1);
	for(x=0;x<3;x++) {
		vid_inv3d(&vidbm,XSPR+10*x,YSPR+3,XSPR+10*x+3,YOFF+4+64);
		vd->bltpattern(&vidbm,Icon[x],XSPR+10*x-2,YOFF+70,8,8,ST0,ST2);
		sprite_quikmove(&ToneKnob[x],XSPR+10*x-2,YSPR+32);
	};

	mouse_show();

	for(;;) {
		mouse_wait_key();
		mouse_read2(&x,&y,&b);
		if (b&2) break;
		else if (b&1) {
			struct Sprite *spr=ToneKnob;
			for(z=0;z<3;z++) {
				if (sprite_pointcoll(spr,x,y)) {
					long xoff,yoff;
					short oy;

					xoff=x-spr->x;
					yoff=y-spr->y;
					oy=-1;
					while(b&1) {
						y-=yoff;
						if (y<(YSPR)) y=YSPR;
						if (y>(YSPR+64)) y=(YSPR+64);
						if (y!=oy) {
							sprite_quikmove2(spr,spr->x,y);
							TCF((YSPR+64)-ToneKnob[0].y,(YSPR+64)-ToneKnob[1].y,(YSPR+64)-ToneKnob[2].y);
							oy=y;
						};
						mouse_read2(&x,&y,&b);
					};
					break;
				};
				spr++;
			};
		};
	};
	mouse_wait_unkey();

	free(backpal);

	repick_colors();
	restore_screen();
}

/* bright is from 0 to 64; remap from 0 to 65535 */
/* contrast is from 0 to 64; remap from 0 to 65535 */
/* gamma is from 0 to 64; remap from 2^-2 to 2^2 */

static void Try_Colors(uchar ibright,uchar icontrast,uchar igamma) {
	uchar	*cl=piccol;
	ushort	i=768;
	ushort	*src=backpal;
	ushort	y;
	long	z;

	ushort	bright;
	ushort	contrast;
	float	gamma;

	bright=((ulong)ibright*13107)/13;
	contrast=((ulong)icontrast*13107)/13;
	gamma=pow(2,(32-igamma)/16.0);

	mouse_hide();
	vid_printf6(&vidbm,XOFF,YOFF-24,ST0,ST2,"b %+3d",ibright-32);
	vid_printf6(&vidbm,XOFF,YOFF-16,ST0,ST2,"c %+3d",icontrast-32);
	vid_printf6(&vidbm,XOFF,YOFF- 8,ST0,ST2,"g%4.2f",1.0/gamma);
	mouse_show();

	do {
		y=*src++;

		z=(long)bright+((((long)y-32768)*contrast)>>15);
		if (z<0) z=0; else if (z>65535) z=65535;

		y=pow(z/65535.0 , gamma)*65535.99;

		*cl++=y>>8;
	} while(--i);
	vid_loadRGB6(0,piccol,256);
}

static void Try_Colors2(uchar igammar,uchar igammag,uchar igammab) {
	uchar	*cl=piccol;
	ushort	i=256;
	ushort	*src=backpal;

	float	gammar;
	float	gammag;
	float	gammab;

	gammar=pow(2,(32-igammar)/16.0);
	gammag=pow(2,(32-igammag)/16.0);
	gammab=pow(2,(32-igammab)/16.0);

	mouse_hide();
	vid_printf6(&vidbm,XOFF,YOFF-24,ST0,ST2,"R%4.2f",1.0/gammar);
	vid_printf6(&vidbm,XOFF,YOFF-16,ST0,ST2,"G%4.2f",1.0/gammag);
	vid_printf6(&vidbm,XOFF,YOFF- 8,ST0,ST2,"B%4.2f",1.0/gammab);
	mouse_show();

	do {
		*cl++=pow(*src++/65535.0 , gammar)*255.99;
		*cl++=pow(*src++/65535.0 , gammag)*255.99;
		*cl++=pow(*src++/65535.0 , gammab)*255.99;
	} while(--i);
	vid_loadRGB6(0,piccol,256);
}


/***************  MONITOR GAMMA ADJUSTMENT ROUTINES ****************/

#undef XOFF
#undef YOFF
#undef XSPR
#undef YSPR

#define	XOFF	(288)
#define	YOFF	(56)
#define	XSPR	(XOFF+4)
#define	YSPR	(YOFF+2)

void MonitorGammaAdjust(void) {
	long xx;
	mouse_coord x,y,b;
	int z;
	boolean	gamma_adj_save;

	col=RGBset;
	gamma_adj_save = opt.gamma_adjust;
	opt.gamma_adjust=FALSE;

	for(xx=0;xx<64;xx++) {
		z=(xx*85)/21;
		vid_setRGB6(xx    ,z,z,z);
		vid_setRGB6(xx+ 64,z,0,0);
		vid_setRGB6(xx+128,0,z,0);
		vid_setRGB6(xx+192,0,0,z);
	};
	mouse_hide();
	vd->set(&vidbm,ST2);
	vid_draw3d(&vidbm,0,0,319,199);
	vd->hline(&vidbm,1,318,10,ST1);
	vd->hline(&vidbm,1,318,11,ST3);
	vd->text6(&vidbm,160-3*24,2,"Monitor Gamma Adjustment",ST0,ST2);

	vd->text6(&vidbm,2,13,"Adjust the red, green, and blue gamma",ST0,ST2);
	vd->text6(&vidbm,2,21,"levers until the dithered pattern of",ST0,ST2);
	vd->text6(&vidbm,2,29,"each pair has roughly the same bright-",ST0,ST2);
	vd->text6(&vidbm,2,37,"ness as the solid side.",ST0,ST2);

	for(xx=0;xx<256;xx+=64) {
		vid13_grey(&vidbm,34+xx,64,32,64,xx,xx+63);
		vd->bar(&vidbm,xx+2,64,32,64,xx+32);
		vid_inv3d(&vidbm,xx+2,64,xx+2+63,127);
	};

	sprite_3dtranslate(ToneKnobImage,ToneKnobOriginal,sizeof ToneKnobOriginal);
	for(x=0;x<3;x++) {
		ToneKnob[x].width	=8;
		ToneKnob[x].height	=6;
		ToneKnob[x].flags	=SPR_MATTE;
		ToneKnob[x].trans_colr	=STT;
		sprite_init(&ToneKnob[x],ToneKnobImage,ToneKnobSave[x],&vidbm,ToneKnob[x].width);
	};

	vd->hline(&vidbm,XSPR-3,XSPR+6+20,YSPR+63,ST1);
	vd->hline(&vidbm,XSPR-3,XSPR+6+20,YSPR+70,ST1);
	for(x=0;x<3;x++) {
		vid_inv3d(&vidbm,XSPR+10*x,YSPR+3,XSPR+10*x+3,YOFF+4+128);
		vd->bltpattern(&vidbm,ToneIcon[3+x],XSPR+10*x-2,YOFF+134,8,8,ST0,ST2);
	};
	sprite_quikmove(&ToneKnob[0],XSPR+ 0-2,YSPR+128-monitor_redigamma);
	sprite_quikmove(&ToneKnob[1],XSPR+10-2,YSPR+128-monitor_grnigamma);
	sprite_quikmove(&ToneKnob[2],XSPR+20-2,YSPR+128-monitor_bluigamma);

	mouse_show();

	MonitorGammaTry(monitor_redigamma,monitor_grnigamma,monitor_bluigamma);

	for(;;) {
		mouse_wait_key();
		mouse_read2(&x,&y,&b);
		if (b&2) break;
		else if (b&1) {
			struct Sprite *spr=ToneKnob;
			for(z=0;z<3;z++) {
				if (sprite_pointcoll(spr,x,y)) {
					long xoff,yoff;
					short oy;

					xoff=x-spr->x;
					yoff=y-spr->y;
					oy=-1;
					while(b&1) {
						y-=yoff;
						if (y<(YSPR)) y=YSPR;
						if (y>(YSPR+128)) y=(YSPR+128);
						if (y!=oy) {
							sprite_quikmove2(spr,spr->x,y);
							MonitorGammaTry((YSPR+128)-ToneKnob[0].y,(YSPR+128)-ToneKnob[1].y,(YSPR+128)-ToneKnob[2].y);
							oy=y;
						};
						mouse_read2(&x,&y,&b);
					};
					break;
				};
				spr++;
			};
		};
	};
	mouse_wait_unkey();

	opt.gamma_adjust=gamma_adj_save;
	restore_screen();
}

static void MonitorGammaTry(uchar igammar,uchar igammag,uchar igammab) {
	float	gammar;
	float	gammag;
	float	gammab;
	int	i,j;

	gammar=pow(2,(64-igammar)/32.0);
	gammag=pow(2,(64-igammag)/32.0);
	gammab=pow(2,(64-igammab)/32.0);

	mouse_hide();
	vid_printf6(&vidbm,2,198-24,ST0,ST2,"Red gamma:   %1.3f",1.0/gammar);
	vid_printf6(&vidbm,2,198-16,ST0,ST2,"Green gamma: %1.3f",1.0/gammag);
	vid_printf6(&vidbm,2,198- 8,ST0,ST2,"Blue gamma:  %1.3f",1.0/gammab);
	mouse_show();

	monitor_redigamma=igammar;
	monitor_grnigamma=igammag;
	monitor_bluigamma=igammab;

	MonitorGammaSet2(gammar,gammag,gammab);

	for(i=0;i<64;i++) {
		j = expand6to8(i);
		vid_setRGB6(i,monitor_gamma[j]<<2,monitor_gamma[j+256]<<2,monitor_gamma[j+512]<<2);
		vid_setRGB6(i+64,monitor_gamma[j]<<2,0,0);
		vid_setRGB6(i+128,0,monitor_gamma[j+256]<<2,0);
		vid_setRGB6(i+192,0,0,monitor_gamma[j+512]<<2);
	}
}

void	MonitorGammaSet(double gammar,double gammag,double gammab) {
	monitor_redigamma=64.0-32.0*log2(gammar);
	monitor_grnigamma=64.0-32.0*log2(gammag);
	monitor_bluigamma=64.0-32.0*log2(gammab);

	MonitorGammaSet2(gammar,gammag,gammab);
}

static void	MonitorGammaSet2(double gammar,double gammag,double gammab) {
	ushort	i;
	uchar	*mcorr=monitor_gamma;
	uchar	*bcorr=bitmap_gamma;
	double	colr=0.0;
	double	gv;
	double	lg;
	double	igammar,igammag,igammab;

	monitor_rgamma = gammar;
	monitor_ggamma = gammag;
	monitor_bgamma = gammab;

	igammar = 1.0 / gammar;
	igammag = 1.0 / gammag;
	igammab = 1.0 / gammab;

	bcorr[0]=bcorr[64]=bcorr[128]=0;

	for(i=0;i<63;i++) {
		colr+=(1.0/63.0);
		++bcorr;

		lg = log(colr);
		gv=exp(5.5451 + lg * igammar); bcorr[  0]=(uchar)gv;
		gv=exp(5.5451 + lg * igammag); bcorr[ 64]=(uchar)gv;
		gv=exp(5.5451 + lg * igammab); bcorr[128]=(uchar)gv;
	};

	colr=0.0;

	mcorr[0]=mcorr[256]=mcorr[512]=0;

	for(i=0;i<255;i++) {
		colr+=(1.0/255.0);
		++mcorr;

		lg = log(colr);
		gv=exp(lg * gammar + 4.15872682115); mcorr[  0]=(uchar)gv;
		gv=exp(lg * gammag + 4.15872682115); mcorr[256]=(uchar)gv;
		gv=exp(lg * gammab + 4.15872682115); mcorr[512]=(uchar)gv;
	};
}

void MonitorGammaReset(void) {
	uchar *mcorr=monitor_gamma;
	uchar *bcorr=bitmap_gamma;
	long i;

	for(i=0;i<64;i++) {
		bcorr[0]=bcorr[64]=bcorr[128]=(i*85L)/21;
		++bcorr;
	};

	for(i=0;i<256;i++) {
		mcorr[0]=mcorr[256]=mcorr[512]=i>>2;
		++mcorr;
	};

	opt.gamma_adjust=FALSE;
}

//////////////////////////////// COLOR CONTROL //////////////////////////////////

static struct Text cc_text[]={
	{ "Mode"		,  6,14,St0,St2 },
	{ "Bright/Contrast"	, 38,14,St0,St2 },
	{ NULL }
};

static struct Zone cc_zones[]={
	{ 181,12,36,11,ZN_3D+ZN_TEXTRENDER,NULL,"Apply",NULL },
	{ -1,-1,-1,-1 },
	{ 217,12,24,11,ZN_3D+ZN_TEXTRENDER,NULL,"RGB",NULL },
	{ -1,-1,-1,-1 },
};

static struct ZoneRange cc_zoneranges[]={
	{ &cc_zoneranges[1],&cc_zones[0],NULL,-1,ZR_TAP   ,NULL,-1,0,NULL,0 },
	{ NULL		   ,&cc_zones[2],NULL,-1,ZR_TOGGLE,NULL,-1,0,NULL,0 },
};

static struct Slider cc_sld[]={
	{
		&cc_sld[1],{NULL},NULL,
		{  14, 28,129,  6 },
		NULL,0,0,4,4,
		0,0,512,0,
		8,8,0,0,0,0,
		REQSLD_ONEHIT+SLD_ARROW1HIT+SLD_ARROW2HIT+SLD_ARROW1*4+SLD_ARROW2*6+SLD_OUTLINE3D,
		&CC_Updater2,
		{   2, 26, 10, 10 },
		{ 145, 26, 10, 10 },
		-1,0,1,0,
		NULL,
	},{
		&cc_sld[2],{NULL},NULL,
		{  14, 38,129,  6 },
		NULL,0,0,4,4,
		0,0,512,0,
		8,8,0,0,0,0,
		REQSLD_ONEHIT+SLD_ARROW1HIT+SLD_ARROW2HIT+SLD_ARROW1*4+SLD_ARROW2*6+SLD_OUTLINE3D,
		CC_Updater1,
		{   2, 36, 10, 10 },
		{ 145, 36, 10, 10 },
		-1,0,1,0,
		NULL,
	},{
		NULL,{NULL},NULL,
		{  14, 48,129,  6 },
		NULL,0,0,4,4,
		0,0,512,0,
		8,8,0,0,0,0,
		REQSLD_ONEHIT+SLD_ARROW1HIT+SLD_ARROW2HIT+SLD_ARROW1*4+SLD_ARROW2*6+SLD_OUTLINE3D,
		&CC_Updater1,
		{   2, 46, 10, 10 },
		{ 145, 46, 10, 10 },
		-1,0,1,0,
		NULL,
	}
};

static struct Rectangle cc_pos[]={
	{  2, 12, 32, 11 },
	{ RECT_END }
};

static struct Rectangle cc_neg[]={
	{ 284,17,34,34 },
	{ 249,17,34,34 },
	{ RECT_END }
};

static struct Requester cc_req={
	0,0,320,58,REQ_BORDER+REQ_POPCEN,
	"Color Control",
	St2,
	NULL,		/* listboxes */
	NULL,		/* fields */
	cc_zoneranges,	/* zoneranges */
	cc_sld,		/* sliders */
	cc_pos,		/* positives */
	cc_neg,		/* negatives */
	cc_text,	/* texts */
	NULL
};

static struct Menu cc_menu[]={
	{ MN_START,NULL,"Bright/Contrast"	,NULL },
	{ MN_INIT ,NULL,"Gamma"			,NULL },
	{ MN_INIT ,NULL,"Quantize"		,NULL },
	{ MN_END  ,NULL,"Amplify"		,NULL },
};

static struct CCTranslator {
	void (*xlator)(uchar *xlat);
	short	xinit,yinit,vinit;
	float	upd_div;
	float	upd_add;
	float	upd_exp;
	char *formstr;
} cc_translators[]={
	{ &CCT_Brightness	,+  0,+  0,+ 64, 64.00,+  0.0,0,"%+6.3f"	},	// -4.000 to +4.000
	{ &CCT_Gamma		,+  0,+  0,+  0,128.00,+  0.0,2,"%+6.3f"	},	// +0.250 to +4.000
	{ &CCT_Quantize		,+  0,+  0,+256,2.0078,+128.5,0,"%3.0f   "	},	// __1 to 256
	{ &CCT_Amplify		,+  0,+  0,+  0,2.0078,+127.5,0,"%3.0f   "	},	// +0.000 to +255.000
};

static uchar *cc_chroma;
static uchar *cc_translate;
static uchar *cc_palette;
static ulong *cc_histogram;
static short cc_translator;
static struct CCTranslator *cc_xptr;

static float cc_xlatval;
static short cc_xoffset;
static short cc_yoffset;
static boolean cc_RGBmode=FALSE;

static void ColorControl_ResetSliders(void) {
	SliderAbs(&cc_sld[0],cc_translators[cc_translator].vinit+256,0);
	SliderAbs(&cc_sld[1],cc_translators[cc_translator].xinit+256,0);
	SliderAbs(&cc_sld[2],cc_translators[cc_translator].yinit+256,0);
}

void ColorControl(void) {
	mouse_coord mx,my,mb;
	ulong msg;
	struct Rectangle temprect;

	cc_chroma=cc_translate=cc_palette=NULL;
	cc_histogram=NULL;
	if (!(cc_chroma   =malloc(sizeof(uchar [1024])))) goto cleanup;
	if (!(cc_translate=malloc(sizeof(uchar [ 256])))) goto cleanup;
	if (!(cc_palette  =malloc(sizeof(uchar [ 768])))) goto cleanup;
	if (!(cc_histogram=malloc(sizeof(ulong [ 256])))) goto cleanup;

	PaletteToChroma(cc_chroma,piccol);
	HistogramV(cc_histogram,picbm,cc_chroma);

	cc_translator=0;
	cc_xptr=&cc_translators[0];

	if (!OpenRequester(&cc_req,0,0)) goto cleanup;

	ColorControl_ResetSliders();

	while(mouse_read2(&mx,&my,&mb),(mb&2)==0) {
		if (mb) {
			switch(msg=CheckRequester(&cc_req,mx,my,mb)) {
			case RZoneMsg(0,0):	/* apply */
				memcpy(piccol,cc_palette,768);
				PaletteToChroma(cc_chroma,piccol);
				ColorControl_ResetSliders();
				break;
			case RZoneMsg(0,1):	/* RGB toggle */
				cc_RGBmode=cc_zones[2].flags & ZN_INVERTED;
				break;
			case REQM_NOTHING:
				if (rectInside(&cc_pos[0],mx-cc_req.curx,my-cc_req.cury)) {
					temprect=cc_pos[0];
					temprect.x+=cc_req.curx;
					temprect.y+=cc_req.cury+2;
					rectI3D(&cc_pos[0]);
					PopupMenu(&cc_menu,&temprect,MP_RIGHT);
					rectD3D(&cc_pos[0]);
					if (choice[1]>-1) {
						cc_translator=choice[1];
						cc_xptr=&cc_translators[cc_translator];
						mouse_hide();
						vid_printf6(&cc_req.reqbm,38,14,ST0,ST2,"%-23s",cc_menu[cc_translator].name);
						mouse_show();
						ColorControl_ResetSliders();
					};
				};
				break;
			};
			mouse_wait_unkey();
		};
		if (kbhit()) {
			getch();
			vid_loadRGB6(0,piccol,256);
		};
	};
	mouse_wait_unkey();
	CloseRequester(&cc_req);
cleanup:
	vid_loadRGB6(0,piccol,256);
	if (cc_chroma) free(cc_chroma);
	if (cc_translate) free(cc_translate);
	if (cc_palette) free(cc_palette);
	if (cc_histogram) free(cc_histogram);
}

static void CC_Updater1(struct Slider *sld) {
	mouse_hide();
	vid_printf6(sld->destbm,sld->arrow2.x+sld->arrow2.width+4,sld->arrow2.y+1,ST0,ST2,"%+4d",sld->cposx-256);
	mouse_show();
	CC_DisplayTranslate();
}

static void CC_Updater2(struct Slider *sld) {
	float val;

	val=(sld->cposx-256)/cc_xptr->upd_div+cc_xptr->upd_add;
	if (cc_xptr->upd_exp) val=pow(cc_xptr->upd_exp,val);

	cc_xlatval=val;

	mouse_hide();
	vid_printf6(sld->destbm,sld->arrow2.x+sld->arrow2.width+4,sld->arrow2.y+1,ST0,ST2,
		cc_xptr->formstr,val);
	mouse_show();
	CC_DisplayTranslate();
}

static void CC_DisplayTranslate(void) {
	short x;
	ulong histo[32];
	ulong histomax;
	coord xbase,ybase;

	cc_xoffset=cc_sld[1].cposx-256;
	cc_yoffset=cc_sld[2].cposx-256;
	cc_xptr->xlator(cc_translate);

	memset(histo,0,sizeof histo);
	for (x=0;x<256;x++) histo[cc_translate[x]>>3]+=cc_histogram[x];
	histomax=1;
	for(x=0;x<32;x++) if (histo[x]>histomax) histomax=histo[x];

	xbase=cc_neg[0].x+1;
	ybase=cc_neg[0].y+32;

	mouse_hide();

	vd->bar(&cc_req.reqbm,xbase,ybase-31,32,32,ST2);

	for(x=0;x<256;x++) {
		vd->plot(&cc_req.reqbm,xbase+(x>>3),ybase-(cc_translate[x]>>3),ST0);
	}

	xbase=cc_neg[1].x+1;
	ybase=cc_neg[1].y+32;

	vd->bar(&cc_req.reqbm,xbase,ybase-31,32,32,ST2);

	for(x=0;x<32;x++) {
		vd->vline(&cc_req.reqbm,xbase+x,ybase,ybase-((histo[x]*31)/histomax),ST0);
	}

	mouse_show();

	if (cc_RGBmode)
		RGBTranslate8(cc_palette,piccol,cc_translate);
	else
		ChromaToPalette(cc_palette,cc_chroma,cc_translate);

	vid_loadRGB6(0,cc_palette,256);
}


/////////////////// COLOR CONTROL TRANSLATORS ///////////////////


void CCT_Brightness(uchar *xlat) {
	short x,y;

	for(x=0;x<256;x++) {
		y=((x+cc_xoffset-128)*cc_xlatval)+128+cc_yoffset;
		if (y<0) y=0; else if (y>255) y=255;
		*xlat++=y;
	}
}

void CCT_Gamma(uchar *xlat) {
	double x,xt;
	double xoff;
	short y;

	xoff=cc_xoffset/255.0;

	for(x=0;x<=1;x+=(1.0/255.0)) {
		xt=x+xoff;
		if (xt<0.0) xt=0.0; else if (xt>=1.0) xt=1.0;
		y=(int)(pow(xt,cc_xlatval)*255.0)+cc_yoffset;
		if (y<0) y=0; else if (y>255) y=255;
		*xlat++=y;
	};
}

// q2 should scale 0-127 as 0 and 128-255 as 255

void CCT_Quantize(uchar *xlat) {
	short x,y,z;

	z=cc_xlatval;
	if (z>1)
		for(x=0;x<256;x++) {
			y=((((x+cc_xoffset)*z)>>8)*255)/(z-1)+cc_yoffset;
			*xlat++=y;
		}
	else	qsetl((void*)xlat,0,64);
}


void CCT_Amplify(uchar *xlat) {
	short x,z;
	short maxval;

	z=cc_xlatval;
	if (z>0) {
		z=256-z;
		maxval=128+z;
		for(x=-128;x<128;x++) {
//			*xlat++=((int)(x-128)<<8)/(abs(x-128)+(256-z))+128;
			*xlat++=(maxval*x)/(abs(x)+z)+128;
		}
	} else	for(x=0;x<256;x++) *xlat++=x;
}


/////////////////// GENERAL ROUTINES /////////////////////



//	void PaletteToChroma(short *chroma,const uchar *palette)
//
//	Convert an array of 256 RGB (0-255) palette values to 256 RGBI chroma values
//	(0-255).  One of the chroma values for each color will always be 255.
//	Black (0,0,0) is converted to the (255,255,255) chroma.

void	PaletteToChroma(uchar *chroma,const uchar *palette) {
	short cl;
	uchar r,g,b;
	uchar maxcl;

	for(cl=256;cl;cl--) {
		r=*palette++;
		g=*palette++;
		b=*palette++;
		maxcl=max(max(r,g),b);
		if (!maxcl) {
			*chroma++=255;
			*chroma++=255;
			*chroma++=255;
		} else {
			*chroma++=(((short)r*255)+(maxcl>>1))/maxcl;
			*chroma++=(((short)g*255)+(maxcl>>1))/maxcl;
			*chroma++=(((short)b*255)+(maxcl>>1))/maxcl;
		};
		*chroma++=maxcl;
	};
}

//	void ChromaToPalette(uchar *palette,const uchar *chroma,const uchar *translate);
//
//	Convert an array of 256 RGBI (0-255) chroma values to 256 RGB color values
//	(0-255) through a translation array.

void	ChromaToPalette(uchar *palette,const uchar *chroma,const uchar *translate) {
	short cl;
	uchar r,g,b,i;

	for(cl=256;cl;cl--) {
		r=*chroma++;
		g=*chroma++;
		b=*chroma++;
		i=translate[*chroma++];
		*palette++=r*i/255;
		*palette++=g*i/255;
		*palette++=b*i/255;
	};
}

//	void RGBTranslate8(uchar *dest,const uchar *src,const uchar *translate);
//
//	Translate an array of 256 8-bit RGB values (768 values) through an 8-bit
//	translation array.

void	RGBTranslate8(uchar *dest,const uchar *src,const uchar *translate) {
	short cl;

	for(cl=768;cl;cl--)
		*dest++=(translate[(short)*src++]>>2);
}


//	void Histogram(ulong *hmem,const BMP src);
//
//	Take a histogram of the color indices of all pixels in a bitmap.

void	Histogram(ulong *hmem,const BMP src) {
	uchar *vm;
	coord xs,xst,ys;
	coord vmod;

	memset(hmem,0,sizeof(ulong[256]));
	vm=src->vm+src->x1+src->y1*src->bpr;
	vmod=src->bpr-(xst=src->width);
	ys=src->height;
	do {
		xs=xst;
		do {
			hmem[*vm++]++;
		} while(--xs);
		vm+=vmod;
	} while(--ys);
}

//	void HistogramV(ulong *hmem,const BMP src,const uchar *chroma);
//
//	Take a histogram of the brightnesses of all pixels in a bitmap.

void	HistogramV(ulong *hvmem,const BMP src,const uchar *chroma) {
	ulong hm[256];
	short x;

	Histogram(hm,src);
	memset(hvmem,0,sizeof(ulong[256]));
	for(x=0;x<256;x++)
		hvmem[chroma[x*4+3]]+=hm[x];
}

