#ifndef	VGAPAINT_TOOLS_H
#define	VGAPAINT_TOOLS_H

//#include "vgapaint.h"

#define	RECT_END	(-0x80000000)

struct Rectangle {
	long x,y,width,height;
};

#define	ZN_INVERTED	(0x00000001)
#define	ZN_FRAME	(0x00000003)
#define	ZN_3D		(0x00000010)
#define	ZN_RIGHTSPECIAL	(0x00000020)
#define	ZN_TEXTRENDER	(0x00000040)
#define	ZN_AUTOWIDTH	(0x00000080)
#define	ZN_FITRIGHT	(0x00000100)
#define	ZN_SYSTEXT	(0x00000200)
#define	ZN_LEFTSPECIAL	(0x00000400)
#define	ZN_DISABLED	(0x00000800)
#define	ZN_INSTANT	(0x00001000)

typedef void (*ZoneHitHandler)(struct ZoneRange *,struct Zone *,short,short);
typedef	void (*ZoneDispHandler)(struct ZoneRange *,struct Zone *,short,char);

struct Zone {
	long x,y,xs,ys;
	ulong flags;
	ZoneHitHandler cusVec;
	union {
		char *text;
		ZoneDispHandler dispVec;
	};
	ZoneHitHandler rightVec;
	struct Rectangle req_savepos;
};

#define ZR_CUSTOM	(0x0000)
#define ZR_CHOICE	(0x0001)
#define ZR_TOGGLE	(0x0002)
#define	ZR_TAP		(0x0003)

#define	ZR_TYPEMASK	(0x0003)

struct ZoneRange {
	struct ZoneRange *next;
	struct Zone *zonelist;
	struct Zone *highlighted;
	short highindex;
	ushort flags;
	struct Zone *auxhighlighted;	/* custom handlers only */
	short auxhighindex;		/* custom handlers only */
	short page;			/* custom handlers only */
	void (*refVec)(struct ZoneRange *);	/* refresh handler */
	boolean doubleClick;
};

#define	ZoneMsg(zr,z)	((((long)zr)<<16)+z)
#define	ZoneMR(msg)	((msg)>>16)
#define	ZoneMZ(msg)	((ushort)(msg))

#ifndef VGAPAINT_TOOLS_C
extern ulong	tools3d[];
extern ulong	tools3d_hires[];
extern ushort tools[];
extern ulong toolicons[12][12];
extern ulong toolicons_hires[12][48];
extern ulong tool_continuous_icon[3][12];
extern ulong tool_continuous_icon_hires[3][48];
extern ushort arrowleft[15];
extern ushort arrowright[15];
extern ushort arrowup[15];
extern ushort arrowdown[15];
extern ushort triright[];
extern struct Zone ZTool1[];
extern struct Zone ZTool2[];
extern struct Zone ZTool3[];
extern struct Zone ZTool4[];
extern struct Zone ZTool5[];
extern struct ZoneRange ZRTool1[];
extern struct Rectangle ToolRects[];
#endif

#endif

