#ifndef	VGAPAINT_VGADECODE_H
#define	VGAPAINT_VGADECODE_H

#include "capture.h"

#include <a/types.h>

#define	VGA_OVERFLOW_VRETRACE9	(0x80)
#define	VGA_OVERFLOW_VDISPENA9	(0x40)
#define	VGA_OVERFLOW_VTOTAL9	(0x20)
#define	VGA_OVERFLOW_LINECOMP8	(0x10)
#define	VGA_OVERFLOW_VBLSTART8	(0x08)
#define	VGA_OVERFLOW_VRETRACE8	(0x04)
#define	VGA_OVERFLOW_VDISPENA8	(0x02)
#define	VGA_OVERFLOW_VTOTAL8	(0x01)

#define	VGA_OUTPUT_BYTE		(0x00)
#define	VGA_OUTPUT_WORD		(0x01)
#define	VGA_OUTPUT_DWORD	(0x02)

#define	VGA_MEMORY_ODD_EVEN	(0x00)
#define	VGA_MEMORY_PLANAR	(0x01)
#define	VGA_MEMORY_CHAINED	(0x02)
#define	VGA_MEMORY_MODEX	(0x03)

#define	VGA_DISPLAY_25MHZ	(0x00)
#define	VGA_DISPLAY_28MHZ	(0x01)
#define	VGA_DISPLAY_EXTERN1	(0x02)
#define	VGA_DISPLAY_EXTERN2	(0x03)

#define	VGA_DISPLAY_400LINES	(0x04)
#define	VGA_DISPLAY_350LINES	(0x08)
#define	VGA_DISPLAY_480LINES	(0x0c)

struct VGADecode {
	ushort		horiz_total;
	ushort		horiz_displayed;
	ushort		horiz_blank_start;
	ushort		horiz_blank_end;
	ushort		horiz_retrace_start;
	ushort		horiz_retrace_end;
	ushort		vert_total;
	ushort		vert_displayed;
	ushort		vert_blank_start;
	ushort		vert_blank_end;
	ushort		vert_retrace_start;
	ushort		vert_retrace_end;
	uchar		row_count;
	uchar		row_fine_scroll;
	uchar		row_underline;
	uchar		pad_1;
	ushort		start_address;
	ushort		cursor_address;
	uchar		cursor_start;
	uchar		cursor_end;
	ushort		logical_width;
	ushort		line_compare;

	void *		aperture_start;
	ulong		aperture_size;
	ushort		aperture_io;

	uchar		output_mode;
	uchar		pix_mult;
	uchar		memory_mode;
	uchar		display_mode;
	uchar		write_mode;
};

void	Decode_VGA(struct VGACapture *vc, struct VGADecode *vd);

#endif

