#define	VGAPAINT_VIDEOH_C
#include "videoh.h"

boolean	vidH_init(enum VD_InitCode vdic,long x,long y) {
	void *realvm;

	switch(vdic) {
	case VD_STARTUP:
		vds=&vdh_specs;
		vidbm.vm=NULL;
		if (!(realvm=malloc(640*200))) return FALSE;
		vid_initBitMap(&vidbm,(uchar *)realvm,0,0,640,200,640,piccol);
	case VD_REINIT:
	case VD_FROM13:
		vid_setmode(0x13);

		// this mode is sorely hacked
		// because it hacks up 13h, the picture is scrolled 1 pixel
		// to compensate we back-scroll 1 pixel by setting scroll to 7 and using $FFFF as start address

		disable();
		do {} while(inportb(0x3da) & 1);	// make sure we catch the starting edge
		do {} while(!(inportb(0x3da) & 1));

		x=vid_get_attr(0x10) & 0xbf;
		outp(0x3c0,0x10); outp(0x3c0,x);	/* go to 640x200 mode */
		outp(0x3c0,0x13); outp(0x3c0,7);	// scroll=7
		outp(0x3c0,0x20);
		enable();
		outp(0x3d4,0x0c); outp(0x3d5,0xff);	// start-pos = $FFFF
		outp(0x3d4,0x0d); outp(0x3d5,0xff);

		outportb(0x3c6,15);
//		for(x=0;x<16;x++) vid_setpreg(x,0);

		vid_initBitMap(&realvidbm,(uchar *)0xA0000,0,0,640,200,320,vidbm.pal);	/* the bpr is funny but necessary */
		vidbm.syncrect=TRUE;
		vidbm.syncx1=vidbm.syncy1=0x7FFF;
		vidbm.syncx2=vidbm.syncy2=-0x8000;
		maxclr=16;
		break;
	case VD_CLOSEDOWN:
	case VD_TO13:
		vid_setmode(0x13);
		vid_initBitMap(&realvidbm,(uchar *)0xA0000,0,0,320,200,200,piccol);
		vidbm.syncrect=FALSE;
		if (vdic==VD_CLOSEDOWN)
			if (vidbm.vm) free(vidbm.vm);
		break;
	case VD_RESIZE:
		return FALSE;
	case VD_SETSIZE:
		return FALSE;
	};
	return TRUE;
}

uchar *	vidH_depack(uchar *dest,uchar *src,ulong length);
#pragma aux vidH_depack=	\
	"l:",			\
	"mov al,[esi]",		\
	"inc esi",		\
	"mov ah,al",		\
	"shr al,4",		\
	"mov [edi],al",		\
	"and ah,15",		\
	"mov [edi+1],ah",	\
	"add edi,2",		\
	"dec ecx",		\
	"jne l"			\
	value [esi] parm [edi] [esi] [ecx] modify exact [ax ecx esi edi];

uchar *	vidH_pack(uchar *dest,uchar *src,ulong length);
#pragma aux vidH_pack=		\
	"l:",			\
	"mov ah,[esi]",		\
	"shl ah,4",		\
	"mov al,[esi+1]",	\
	"and al,15",		\
	"add al,ah",		\
	"mov [edi],al",		\
	"add esi,2",		\
	"inc edi",		\
	"dec ecx",		\
	"jne l",		\
	value [edi] parm [edi] [esi] [ecx] modify exact [ax ecx esi edi];

void	vidH_rhline(coord x,coord y,uchar *dm1,coord xs) {
	uchar *vm;

	vm=(uchar *)0xA0000+(x>>1)+y*320;

	if (x & 1) {	/* are we starting on an odd boundary? */
		vm[0]=(vm[0]&0xf0)+(*dm1++ & 0x0f);
		++vm;
		if (!--xs) return;
	};

	if (xs>1) vm=vidH_pack(vm,dm1,xs>>1);
	dm1+=xs;
	if (xs&1) *vm=(*vm & 15)+(dm1[-1]<<4);
}

void	vidH_rhlineread(coord x,coord y,uchar *dm1,coord xs) {
	uchar *vm;

	vm=(uchar *)0xA0000+(x>>1)+y*320;

	if (x&1) {	/* are we starting on an odd boundary? */
		*dm1++=*vm++ & 15;
		if (!--xs) return;
	};

	if (xs>1) vm=vidH_depack(dm1,vm,xs>>1);
	dm1+=xs;
	if (xs&1) dm1[-1]=*vm>>4;
}

void	vidH_rbitblt(coord x,coord y,coord xs,coord ys,uchar *dm1,long dmod,boolean no_offset) {
	uchar *vm;
	long xst;
	long vmod;

	if (xs<=0) return;
	if (ys<=0) return;

	if (!no_offset) dm1+=x+y*vidbm.bpr;

	vm=(uchar *)0xA0000+(x>>1)+y*320;
	vmod=320-(((x&1)+xs+1)>>1);
	dmod-=xs;

	do {
		xst=xs;

		if (x & 1) {	/* are we starting on an odd boundary? */
			vm[0]=(vm[0]&0xf0)+(*dm1++ & 0x0f);
			++vm;
			if (!--xst) goto next;
		};

		if (xst>1) vm=vidH_pack(vm,dm1,xst>>1);
		dm1+=xst;
		if (xst&1) *vm++=(*vm & 15)+(dm1[-1]<<4);
next:
		vm+=vmod;
		dm1+=dmod;
	} while(--ys);
}

void	vidH_rbitbltread(uchar *dm1,coord x,coord y,coord xs,coord ys,long dmod,boolean no_offset) {
	uchar *vm;
	long xst;
	long vmod;

	if (xs<=0) return;
	if (ys<=0) return;

	if (!no_offset) dm1+=x+y*vidbm.bpr;

	vm=(uchar *)0xA0000+(x>>1)+y*320;
	vmod=320-(((x&1)+xs+1)>>1);
	dmod-=xs;

	do {
		xst=xs;

		if (x & 1) {	/* are we starting on an odd boundary? */
			*dm1++=*vm++ & 15;
			if (!--xst) goto next;
		};

		if (xst>1) vm=vidH_depack(dm1,vm,xst>>1);
		dm1+=xst;
		if (xst&1) dm1[-1]=*vm++>>4;
next:
		vm+=vmod;
		dm1+=dmod;
	} while(--ys);
}

/* be very careful with the pointer functions -- they are called
** when SS != DS, and ES != DS.  That means use qmovebes() and no
** pointers to automatic variables. */

#pragma off (check_stack)

void	vidH_drawptr(struct MousePointerInfo *mpi,coord x,coord y) {
	ushort xs=mpi->s_width,ys=mpi->s_height,xst,yst;
	uchar *dp1,*dp2,c;

	dp1=mpi->image;

	if (x<=-mpi->s_width) return;
	else if (x>=vidbm.width) return;
	else if (x>(vidbm.width-mpi->s_width)) xs=vidbm.width-x;
	else if (x<0) { xs=mpi->s_width+x; dp1-=x; x=0; }

	if (y<=-mpi->s_height) return;
	else if (y>=vidbm.height) return;
	else if (y>(vidbm.height-mpi->s_height)) ys=vidbm.height-y;
	else if (y<0) { ys=mpi->s_height+y; dp1-=(y*mpi->s_width); y=0; }

	mpi->width=xs;
	mpi->height=ys;
	mpi->saved_x=x;
	mpi->saved_y=y;

//	VUOSave=vidH_UseOffset;
//	vidH_UseOffset=FALSE;

	vidH_rbitbltread(mpi->backup,x,y,xs,ys,xs,TRUE);

	qmovel((void*)mpi->blitmem,(void*)mpi->backup,(mpi->s_width*mpi->s_height)/4);

	dp2=mpi->blitmem;

	yst=ys;
	do {
		xst=xs;
		do {
			if (c=*dp1) *dp2=c-1 ? mpi->high : mpi->low;
			++dp1,++dp2;
		} while(--xst);
		dp1+=(mpi->s_width-xs);
	} while(--yst);

	vidH_rbitblt(x,y,xs,ys,mpi->blitmem,xs,TRUE);

//	vidH_UseOffset=VUOSave;
}

void	vidH_eraseptr(struct MousePointerInfo *mpi) {
	ushort xs,ys;

	if ((xs=mpi->width)<=0) return;
	if ((ys=mpi->height)<=0) return;

//	VUOSave=vidH_UseOffset;
//	vidH_UseOffset=FALSE;
	vidH_rbitblt(mpi->saved_x,mpi->saved_y,xs,ys,mpi->backup,xs,TRUE);
//	vidH_UseOffset=VUOSave;
}

#pragma on (check_stack)
